
local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_CrystallineDust=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_CrystallineDust
	
	function class:GetName()
		return "Crystalline Dust"
	end		
	
	function class:SetCustomInfo()
		-- wowhead database says 25yd range
		super.SetCustomInfo(self)
		-- cast duration is currently based on animation timing
		self.basecastduration=0.3
		self.range=nil
		--TODO: does not set GCD, is not affected by GCD
		self.basegcd=1.0	-- taeshtech GCD is applied at the END of the cast
		self.blockqueueingwhilecasting=true
	end
	
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		--face towards edge
		local angle=math.atan(caster.y,caster.x)		
		
		-- --!!!
		-- angle=angle-math.pi
		
		self.angle=angle
		caster.targetfacing_3D=angle
		local aura=self.castercombat:ApplyAuraByClass(TRAININGGROUNDS_Aura_Facing_Direction_WhileCasting,self.castercombat)
		aura.turnspeed=10
		aura.targetfacing=angle		
		
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)
		self.telegraph={}
		self.telegraph.x=self.castercombat.owner.x+yard*10*math.cos(angle)
		self.telegraph.y=self.castercombat.owner.y+yard*10*math.sin(angle)		
		self.telegraph.angle=angle
		--telegraph.expiry=caststarttime+3.0
		
		--TODO: face middle of room?
	end		
	
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	
	-- function class:CompleteCasting(castendtime)
		-- super.CompleteCasting(self,castendtime)
	-- end
	
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end	
	
	function class:ExecuteSpellEffect(projectile)
		--TODO: apply debuff and knockback
		--TODO: if player soaks wrong flame rend, call wipe	
		local castermobile=self.castercombat.owner
		local targetx,targety

		local dust=TRAININGGROUNDS_JAINA_Telegraph_CrystallineDust.new()
		local caster=self.castercombat.owner
		--print("Caster:",caster,caster.environment)
		dust:Setup(caster.environment)
		dust.x=self.telegraph.x;dust.y=self.telegraph.y		
		dust.angle=self.angle
		dust.currentfacing=dust.angle
		dust.drawable.frame:SetFacing(dust.currentfacing+math.pi)
		dust.groupdancemodule=caster.groupdancemodule
		dust.expirytime=dust.environment.localtime+1.5	
		--TODO: actually check if the attack hit the player
		local player=dust.groupdancemodule.player
		local hit=false
		--hit detection
		local CONE_LENGTH=yard*30
		local leeway=math.pi/8
		-- we checked point-triangle collision, but for our purposes, player character is a circle, not a point
		local PLAYERRADIUS=yard*1.5
		local x1=dust.groupdancemodule.jaina.x
		local y1=dust.groupdancemodule.jaina.y
		local x2=x1+math.cos(self.angle-leeway)*yard*CONE_LENGTH
		local y2=y1+math.sin(self.angle-leeway)*yard*CONE_LENGTH
		local x3=x1+math.cos(self.angle+leeway)*yard*CONE_LENGTH
		local y3=y1+math.sin(self.angle+leeway)*yard*CONE_LENGTH
		local cx=player.x
		local cy=player.y
		--print("linecircle:",x1,y1,x2,y2)
		if(TRAININGGROUNDS_PointTriangleCollision(player.x,player.y,x1,y1,x2,y2,x3,y3)
		or TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,cx,cy,PLAYERRADIUS)
		or TRAININGGROUNDS_LineCircleCollision(x1,y1,x3,y3,cx,cy,PLAYERRADIUS)
		or TRAININGGROUNDS_LineCircleCollision(x2,y2,x3,y3,cx,cy,PLAYERRADIUS))then
			hit=true
		end
		if(hit)then
			dust.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_CRYSTALLINEDUST,
				source=player.combat})		
			dust.groupdancemodule:ApplyChillingTouchStacks(3,true)
			--knockback, but only if player isn't frozen	
			local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSolid)
			if(#auras==0)then					
				player.zspeed=yard*11.7
				if(player.z<1)then player.z=1 end
				player.xspeed=math.cos(self.angle)*yard*20
				player.yspeed=math.sin(self.angle)*yard*20
			end
		end
	end	
end



do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_JAINA_Telegraph_CrystallineDust=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_CrystallineDust
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=true
		-- self.width=250
		-- self.height=250		
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_CrystallineDust.new()		
		self.drawable:Setup(self,self.environment)
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_CrystallineDust=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_CrystallineDust	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_jaina_crystallinedust_impactworld.m2"
		self.modelfileid=2563794
		self.defaultanimation=0	
		self.camera2Dlocation={15,120,120*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={15,0,-.5}	
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=500
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end