local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_Icefall=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_Icefall
	
	function class:GetName()
		return "Icefall"
	end		
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.basecastduration=1
		self.range=nil
		self.basegcd=1.0
		self.blockqueueingwhilecasting=true
	end
	
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end

	function class:StartCasting(caststarttime)		
		super.StartCasting(self,caststarttime)
		local iconsize="20"
		local icon="\124Tinterface\\icons\\spell_frost_frozencore:"..iconsize.."\124t"
		local link="\124cffff0000\124Hspell:288441\124h[Icefall]\124h\124r"			
		local playername="someone"
		if(i==r)then
			playername="\124cffff0000"..GetUnitName("player").."\124r"
		end		
		local message=icon.."\124cffff0000Lady Jaina Proudmoore\124r begins to cast "..link.."!"
		-- thankfully we handle double icefalls in a single spellcast, so prismatic images won't cause a double message here
		TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)			
	end		
	
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end		
	
	function class:ExecuteSpellEffect(projectile)		
		local castermobile=self.castercombat.owner
		local gdm=castermobile.groupdancemodule
		
		--TODO: if(gdm.prismaticimage and (gdm.prismaticimage.dead~=true))then --double icefall
		
		
		-- angle is the direction of the ice comets.  telegraph will appear on the OPPOSITE edge.
		self.angle=math.random()*math.pi*2
		self:ApplyTelegraph(self.angle)
		
		if(gdm.prismaticimage and (gdm.prismaticimage.dead~=true))then
			local anglemodifier=math.pi/6+math.random()*math.pi*4/6
			if(math.random()>.5)then anglemodifier=-anglemodifier end
			local angle2=self.angle+anglemodifier
			self:ApplyTelegraph(angle2)
		end
		

	
	end	
	
	function class:ApplyTelegraph(angle)	
		local castermobile=self.castercombat.owner	
		local gdm=castermobile.groupdancemodule
		
		local TELEGRAPH_DIST=yard*50
		local telegraph=TRAININGGROUNDS_JAINA_Telegraph_Icefall.new()		
		telegraph:Setup(castermobile.environment)
		telegraph.x=TELEGRAPH_DIST*math.cos(angle+math.pi);telegraph.y=TELEGRAPH_DIST*math.sin(angle+math.pi)
		telegraph.angle=angle;telegraph.currentfacing=telegraph.angle
		telegraph.groupdancemodule=gdm
		telegraph.spellinstance=self

		-- "inner" part of the arrow
		local par=TRAININGGROUNDS_Telegraph_Parallelogram.new()
		par:Setup(castermobile.environment)
		local basex=telegraph.x;local basey=telegraph.y
		local fwdx=math.cos(angle);local fwdy=math.sin(angle)
		local rightx=math.cos(angle-math.pi/2);local righty=math.sin(angle-math.pi/2)
		local SIZE=yard*3*(.75)
		par.drawable:SetColor(1,1,1,1)
		par.drawable:SetShape(basex-fwdx*SIZE,basey-fwdy*SIZE, basex-rightx*SIZE,basey-righty*SIZE, 
								basex+fwdx*SIZE,basey+fwdy*SIZE, basex+rightx*SIZE,basey+righty*SIZE)
		par.visible=true
		par.drawable.visible=true
		par.expirytime=telegraph.environment.localtime+11
		
		-- "pointer" part of the arrow
		local par=TRAININGGROUNDS_Telegraph_Parallelogram.new()
		par:Setup(castermobile.environment)
		par.drawable:SetColor(1,1,1,1)
		local LEN=yard*10*(.75);local WID=yard*1*(.75)
		par.drawable:SetShape(basex,basey, 					basex-rightx*WID+fwdx*LEN/2,basey-righty*WID+fwdy*LEN/2, 
							  basex+fwdx*LEN,basey+fwdy*LEN, basex+rightx*WID+fwdx*LEN/2,basey+righty*WID+fwdy*LEN/2)
		par.visible=true
		par.drawable.visible=true
		par.expirytime=telegraph.environment.localtime+11		
		
		if(gdm.mode_choice==1)then
			print("Icefall arrow")
			local ARROW_LENGTH=yard*80
			local x1=basex+fwdx*LEN*2
			local y1=basey+fwdy*LEN*2
			local x2=basex+fwdx*ARROW_LENGTH
			local y2=basey+fwdy*ARROW_LENGTH
			local arrow=gdm:Arrow(x1,y1,x2,y2,50,100,1,0,0,1,8)
		end
		
	end
	
	
end

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_JAINA_Telegraph_Icefall=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_Icefall
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=false	--TODO: is this redundant?
		self.cometcount=0
		self.nextcomet=11.00
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Icefall_Telegraph.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		self.drawable.frame:SetFacing(self.currentfacing)
		if(self.state==1 and self.alivetime>0.25)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>10.0)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end		
		if(self.state==3 and self.alivetime>11.0)then
			self.state=self.state+1
			self.visible=false
			--TODO: big comet
		end
		if(self.state==4)then
			if(self.alivetime>=self.nextcomet)then
				self.nextcomet=self.nextcomet+1/6				
				--TODO: comets, not voidzones
				local comet=TRAININGGROUNDS_JAINA_Icefall_Comet.new()
				comet:Setup(self.environment)
				comet.spellinstance=self.spellinstance		
				comet.groupdancemodule=self.groupdancemodule				
				local COMETSIZE=yard*7.5
				local COMETVARIATION=COMETSIZE
				local variationradius=COMETVARIATION
				if(self.cometcount==0)then variationradius=0 end
				local varangle=math.random()*math.pi*2
				local varx=math.cos(varangle)*variationradius
				local vary=math.sin(varangle)*variationradius
				local COMETSPACING=yard*100/12
				
				comet.x=self.x+math.cos(self.angle)*self.cometcount*COMETSPACING+varx
				comet.y=self.y+math.sin(self.angle)*self.cometcount*COMETSPACING+vary
				comet.z=1
				comet.zspeed=0---yard*10*4
				comet.cometcount=self.cometcount
				
				
				self.cometcount=self.cometcount+1				
				if(self.cometcount>=13)then
					self:Die()
				end
			end
		end
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Icefall_Telegraph=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Icefall_Telegraph

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		---- comet impact		
		-- we can't use any of the "correct" precast effects for icefall as they don't display properly
		--self.modelfilename="spells/8fx_jaina_icefall.m2"				
		self.modelfilename="spells/target_water_state_rimonly.m2"
		self.modelfileid=1012303
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.7}		
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=950*(7.5/10)
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
end

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_JAINA_Icefall_Comet=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Icefall_Comet
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
		self.state=1
		self.alivetime=0
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Icefall_Comet.new()		
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.alivetime>=0.5 and self.state==1)then
			self.state=self.state+1
			local void=TRAININGGROUNDS_JAINA_FakeVoidZone_ArcticGround_Circle.new()
			void:Setup(self.environment,self.spellinstance)
			void.x=self.x;void.y=self.y
			
			--hit detection, 10 stacks if hit
			local player=self.groupdancemodule.player
			local distsqr=(player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y)
			if(distsqr<=yard*7.5*yard*7.5)then
				self.groupdancemodule:ApplyChillingTouchStacks(10,true)
				self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_ICEFALL,
					source=player.combat})		

			end
			
			--if cometcount==7, apply 20s iceblock to simulate random careless player
			if(self.cometcount==7)then
				self.groupdancemodule:ApplyIceblockAndLances(self.x,self.y,20)
			end
			
			--the animation continues for another second or so, but it's not terribly compatible with the camera system so we stop it here
			self:Die()
		end

	end
	
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Icefall_Comet=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Icefall_Comet

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		-- comet impact
		self.modelfilename="spells/8fx_jaina_icefall.m2"				
		-- we can't use any of the "correct" precast effects for icefall as they don't display properly		
		-- self.camera2Dlocation={0,80,80*.707}	--TODO: use camera ystretch
		-- self.camera2Dtarget={0,0,-0.7}	
		self.camera2Dlocation={0,160,160*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.7}	
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=950*(7.5/10)
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end





-----------------------------------------------------------------------------------------

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_Telegraph_Parallelogram=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Telegraph_Parallelogram
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite_Parallelogram:new()
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_Sprite
	TRAININGGROUNDS_Drawable_Sprite_Parallelogram=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Drawable_Sprite_Parallelogram	
	
	function class:CreateFrame()		
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame2=TRAININGGROUNDS_ReusableFrames:GetFrame()		
		self.frames={}
		tinsert(self.frames,self.frame)
		tinsert(self.frames,self.frame2)
	end	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.visible=true
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer		
	end	
	function class:SetFrameLevel()
		for i=1,#self.frames do
			self.frames[i]:SetFrameLevel(self.framelayer.level)
		end
	end		
	function class:ShowFrames()	
		for i=1,#self.frames do	self.frames[i]:SetAlpha(self.alpha)	end
	end
	function class:HideFrames()	
		for i=1,#self.frames do	self.frames[i]:SetAlpha(0) end
	end	
	function class:SetFrameAppearance()
		--texture will be setup during TAXIFRAME_TextureAdd
		self.width=100
		self.height=100
		--TODO: width/height should go here, but should we move SetParent+SetPoint somewhere else?
		for i=1,#self.frames do
			self.frames[i]:SetParent(self.parentframe)
			self.frames[i]:SetPoint("TOPLEFT",self.parentframe,"CENTER",0,0)
			self.frames[i]:Show()
			self.frames[i]:SetWidth(self.width);self.frames[i]:SetHeight(self.height)		
		end
	end
	--TODO: some arrows need to update position (and/or flash) every frame
	-- 1 2		(triangles are 123 and 341)
	-- 4 3
	function class:SetShape(x1,y1,x2,y2,x3,y3,x4,y4)		
		self:SetFrameVertices(self.frame,x1,y1,x2,y2,x3,y3)
		self:SetFrameVertices(self.frame2,x3,y3,x4,y4,x1,y1)
	end	
	function class:SetFrameVertices(frame,x1,y1,x2,y2,x3,y3)
		frame.x1=x1
		frame.y1=y1
		frame.x2=x2
		frame.y2=y2
		frame.x3=x3
		frame.y3=y3
		--TODO: drawable_polygon:GetYStretchMultiplier()
		local ystretch=self.owner.environment.cameramanager.camera.ystretch
		TAXIFRAME_TextureAdd(frame,100,1,1,1,x1*0.01,-y1*0.01*ystretch,x2*0.01,-y2*0.01*ystretch,x3*0.01,-y3*0.01*ystretch)		
	end	
	function class:SetColor(R,G,B,A)
		for i=1,#self.frames do self.frames[i].texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A) end
	end
	function class:ArrangeFrame(parentanchor,x,y,wid,hgt,yaw,pitch)		
		for i=1,#self.frames do	self.frames[i]:SetParent(self.parentframe) end		
	end	
	function class:SetFrameSizeAndOrientation(wid,hgt,yaw,pitch)
		--do nothing, maybe		
	end		
	function class:Cleanup()
		-- don't call super	--TODO: not calling super might break something down the road
		for i=1,#self.frames do	self.frames[i]:Cleanup() end
	end
end