local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
local BEAMTURNSPEED=math.pi/64*(2/3)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Spell=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Spell
	
	function class:GetName()
		return "Buster Cannon"
	end		
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.basecastduration=2.8
		self.range=nil
		self.basegcd=1.0	-- taeshtech GCD is applied at the END of the cast
		self.blockqueueingwhilecasting=true
	end
	
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		--face towards player, or thereabouts
		local gdm=caster.groupdancemodule
		local player=gdm.player			
		local playerangle=math.atan2(player.y-caster.y,player.x-caster.x)	
		--print("angle:",playerangle)
		local targetangle=playerangle+math.random()*math.pi/4-math.pi/8
		--targetangle=-math.pi/2--!!!
		

				
		self.angle=targetangle
		caster.targetfacing_3D=targetangle
		local aura=self.castercombat:ApplyAuraByClass(TRAININGGROUNDS_Aura_Facing_Direction_WhileCasting,self.castercombat)
		aura.turnspeed=10
		aura.targetfacing=targetangle		
		
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)
		self.telegraph=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Precast.new()
		self.telegraph:Setup(gdm.environment)
		self.telegraph.castercombat=self.castercombat
		self.telegraph.spellinstance=self
		-- self.telegraph.x=self.castercombat.owner.x+yard*2.5*math.cos(targetangle)
		-- self.telegraph.y=self.castercombat.owner.y+yard*2.5*math.sin(targetangle)	
		self.telegraph.xbase=self.castercombat.owner.x
		self.telegraph.ybase=self.castercombat.owner.y	
		self.telegraph.drawable.frame:SetFacing(targetangle)
		self.telegraph.angle=targetangle
		--telegraph.expiry=caststarttime+3.0
		
	
		self.path=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Path.new()
		self.path:Setup(gdm.environment)
		self.path.castercombat=self.castercombat
		self.path.spellinstance=self
		-- self.path.x=self.castercombat.owner.x+yard*2.5*math.cos(targetangle)
		-- self.path.y=self.castercombat.owner.y+yard*2.5*math.sin(targetangle)	
		self.path.xbase=self.castercombat.owner.x
		self.path.ybase=self.castercombat.owner.y	
		self.path.drawable.frame:SetFacing(targetangle)
		self.path.angle=targetangle
		
		
		--TODO: face middle of room?
	end		
	
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.ChannelCastDirected)
	end
	
	-- function class:CompleteCasting(castendtime)
		-- super.CompleteCasting(self,castendtime)
	-- end
	
	function class:CompleteCastingAnimationFunction()			
		self.castercombat.owner.drawable:SetAnimationAndRestart(TRAININGGROUNDS_MEKKATORQUE_ANIMATION_LIST.ChannelCastDirected_Followthrough)
	end	
	
	function class:ExecuteSpellEffect(projectile)
		local castermobile=self.castercombat.owner
		local targetx,targety

		local angle=self.castercombat.owner.currentfacing
		local offset=-math.pi*0.1
		local caster=self.castercombat.owner
		self.x=caster.x+yard*2.2*math.cos(angle+offset)+yard*0*math.cos(angle)
		self.y=caster.y+yard*2.2*math.sin(angle+offset)+yard*0*math.sin(angle)
		local missile=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Missile.new()		
		--print("Caster:",caster,caster.environment)
		missile:Setup(caster.environment)
		missile.castercombat=self.castercombat
		missile.x=self.telegraph.x;missile.y=self.telegraph.y		
		missile.z=yard*1.5
		missile.xbase=self.castercombat.owner.x
		missile.ybase=self.castercombat.owner.y		
		missile.angle=self.angle
		missile.currentfacing=missile.angle
		missile.direction=self.direction
		--missile.drawable.frame:SetFacing(missile.currentfacing)
		missile.groupdancemodule=caster.groupdancemodule
		missile.xspeed=math.cos(angle)*yard*14
		missile.yspeed=math.sin(angle)*yard*14
		
		
		--self.telegraph.missile=missile
		
		--TODO: actually check if the attack hit the player

	end	
end




-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Precast=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Precast
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.nexthitdetecttime=0
		self.ysortable=true	--TODO: is this redundant?
		-- self.width=250
		-- self.height=250		
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Precast_Drawable.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=2.8
		
		local angle=self.castercombat.owner.currentfacing
		local offset=-math.pi*0.1
		--TODO: "currentfacing_3D" apparently not used for anything
	
		if(self.state==1 and self.alivetime>0.5)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end
		if(self.state==3 and self.alivetime>ANIM_TIME+0.5)then
			self.state=self.state+1
			self:Die()
		end
		self.x=self.castercombat.owner.x+yard*2.2*math.cos(angle+offset)
		self.y=self.castercombat.owner.y+yard*2.2*math.sin(angle+offset)
		self.z=yard*1.5
		
		
	end
end

-----------------------------------------

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Precast_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Precast_Drawable

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_mekkatorque_bustercannon_precast.m2"
		self.modelfileid=2457553
		self.scale3D=0.25
		self.positionmultiplier=1/self.scale3D
		self.camerapositionmultiplier=0.6
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Path=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Path
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.nexthitdetecttime=0
		self.ysortable=true	--TODO: is this redundant?
		-- self.width=250
		-- self.height=250		
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Path_Drawable.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=2.8
		
		self.drawable.frame:SetFacing(self.castercombat.owner.currentfacing)		
		local angle=self.castercombat.owner.currentfacing
		local offset=-math.pi*0.1
	
		if(self.state==1 and self.alivetime>0.5)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end
		if(self.state==3 and self.alivetime>ANIM_TIME+0.5)then
			self.state=self.state+1
			self:Die()
		end
		self.x=self.castercombat.owner.x+yard*2.2*math.cos(angle+offset)+yard*0*math.cos(angle)
		self.y=self.castercombat.owner.y+yard*2.2*math.sin(angle+offset)+yard*0*math.sin(angle)
		self.z=yard*1.5
		--print("Facing:",self.drawable.frame:GetFacing())
	
	end
end

-----------------------------------------

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Path_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Path_Drawable

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_mekkatorque_bustercannon_path.m2"
		self.modelfileid=2478312
		self.scale3D=1
		self.positionmultiplier=1/self.scale3D
		self.camerapositionmultiplier=0.6
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end


-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Missile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Missile
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.hitdetect=true
		self.ysortable=true	--TODO: is this redundant?
		-- self.width=250
		-- self.height=250		
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Missile_Drawable.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=6.0
		
		
		if(self.state==1 and self.alivetime>0.5)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end
		if(self.state==3 and self.alivetime>ANIM_TIME+0.5)then
			self.state=self.state+1
			self:Die()
		end
		--print("Facing:",self.drawable.frame:GetFacing())
		self.drawable.frame:SetFacing(self.castercombat.owner.currentfacing)
		
		if(self.hitdetect)then
			local gdm=self.castercombat.owner.groupdancemodule
			local player=gdm.player
			local distsqr=(player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y)
			local leeway=4
			local radiussqr=yard*yard*leeway*leeway
			if(distsqr<=radiussqr)then
				self.hitdetect=false
				gdm:ReactToCustomDanceEvent({action=TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.HIT_BY_BUSTERCANNON,
					source=player.combat})
				player.z=1
				player.zspeed=yard*15
				local angle=math.atan2(player.y-self.y,player.x-self.x)
				player.xspeed=math.cos(angle)*yard*20
				player.yspeed=math.sin(angle)*yard*20
			end
			
		end
		
	end
end

-----------------------------------------

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Missile_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Missile_Drawable

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_mekkatorque_bustercannon_missile.m2"
		self.modelfileid=2457546
		self.scale3D=1
		self.positionmultiplier=1/self.scale3D
		self.camerapositionmultiplier=0.6
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end