local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_MEKKATORQUE_SparkBot_Mobile=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_MEKKATORQUE_SparkBot_Mobile

	function class:GetName()
		--override, don't call super
		return "Spark Bot (mobile) "..tostring(self.id)
	end
	

	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		--self.TEMP_TAG=true
		
		self.nameplatename="Spark Bot"
		self.basemovespeed = 0.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
		--self.baseturnspeed=2.0	
		--self.baseturnspeed_3D=2.0	
		self.faction=TRAININGGROUNDS_Factions.ENEMY
		
		--set after calling setup: 
		self.groupdancemodule=nil	-- (used when spells create further objects)		
		
		--self.nextsparkpulsetime=self.environment.localtime+1	-- set in groupdancemodule, not in here
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_SparkBot_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		if(self.environment.localtime>=self.nextsparkpulsetime)then
			self.nextsparkpulsetime=self.nextsparkpulsetime+5.0
			local sparkpulse=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Telegraph.new()
			sparkpulse:Setup(self.environment)
			sparkpulse.owner=self
			sparkpulse.x=self.x;sparkpulse.y=self.y
			sparkpulse.groupdancemodule=self.groupdancemodule
		end
	end
end

do
	TRAININGGROUNDS_MEKKATORQUE_ANIMATION_LIST={}
	local followthrough=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_MEKKATORQUE_ANIMATION_LIST,"ChannelCastDirected_Followthrough",124,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.ENDCAST,1.0)

	if(not TRAININGGROUNDS_ModelInfos.SparkBot)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=28573
		mi.cameradistance=15
		mi.size=300
		mi.shadowsize=mi.size*0.75
		
		mi.clickboxx=0
		mi.clickboxy=-5
		mi.clickboxwidth=60
		mi.clickboxheight=80
		
		TRAININGGROUNDS_ModelInfos.SparkBot=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_MEKKATORQUE_SparkBot_Drawable = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_MEKKATORQUE_SparkBot_Drawable
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=0.3	--TODO: move to modelinfo
		--self.positionmultiplier=0.9
		self.positionmultiplier=1.2/self.scale3D		
		self.camerapositionmultiplier=1.2
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.SparkBot
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
end

-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Telegraph=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Telegraph
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Telegraph_Drawable.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=4.0
		
		self.x=self.owner.x
		self.y=self.owner.y
		
		if(self.state==1 and self.alivetime>0.25)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)			
			local gdm=self.groupdancemodule
			local player=gdm.player
			local distsqr=(player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y)
			local leeway=4
			local radiussqr=yard*yard*leeway*leeway
			if(distsqr<=radiussqr)then
				gdm:ReactToCustomDanceEvent({action=TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.HIT_BY_SPARKPULSE,
					source=player.combat})
			end			
			local impact=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Impact.new()
			impact:Setup(self.environment)
			impact.x=self.x;impact.y=self.y
			impact.expirytime=self.environment.localtime+1.0
		end
		if(self.state==3 and self.alivetime>ANIM_TIME+0.25)then
			self.state=self.state+1
			
			self:Die()
		end
	
		
		
	end
end

-----------------------------------------

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Telegraph_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Telegraph_Drawable

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/target_water_state.m2"
		self.modelfileid=943459
		self.scale3D=0.5
		self.positionmultiplier=0.6/self.scale3D
		self.camerapositionmultiplier=0.6
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
end

-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------
-----------------------------------------

do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Impact=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Impact
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true	
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Impact_Drawable.new()		
		self.drawable:Setup(self,self.environment)
	end
end

-----------------------------------------

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Impact_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_MEKKATORQUE_SparkPulse_Impact_Drawable

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		--it turns out "lightning_pulse" refers to gigavolt charge, but we can repurpose it for spark pulse...
		self.modelfilename="spells/8fx_mekkatorque_lightning_pulse.m2"
		self.modelfileid=2457729
		self.scale3D=0.0375
		self.positionmultiplier=0.6/self.scale3D
		self.camerapositionmultiplier=0.6
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end