local POSITION_MULTIPLIER=0.61

do
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Decor	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0;self.state=1;self.ysortable=true
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		--self:HitDetect()	-- debug-only: check every frame
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=3.0
		if(self.state==1 and self.alivetime>0.25)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)	
			self:SpawnImpact()
		end
		if(self.state==3 and self.alivetime>ANIM_TIME+0.25)then			
			self:HitDetect()
			self.state=self.state+1			
			self:Die()
		end	
	end
	
	function class:SpawnImpact()
		local impact=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Impact.new()
		impact:Setup(self.environment)
		impact.x=self.x;impact.y=self.y
		impact.expirytime=self.environment.localtime+1.0		
	end
	
	function class:HitDetect()
		local gdm=self.groupdancemodule
		local player=gdm.player
		local distsqr=(player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y)
		local leeway=6
		local radiussqr=yard*yard*leeway*leeway
		if(distsqr<=radiussqr)then
			--print("Distance:",math.sqrt(distsqr)/yard)
			gdm:ReactToCustomDanceEvent({action=TRAININGGROUNDS_ORGOZOA_CustomDanceEventType.HIT_BY_DRIBBLINGICHOR,
				source=player.combat})
		end			
	end
	
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Drawable	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=2924463
		self.scale3D=1	--TODO: probably move to modelinfo
		self.positionmultiplier=POSITION_MULTIPLIER	--TODO: move to modelinfo		
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end	
end

do
	local super=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Decor
	TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Rim=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Rim
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Rim_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end			
	function class:HitDetect()
		-- do nothing
	end	
	function class:SpawnImpact()
		-- do nothing
	end
end
do
	local super=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Drawable
	TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Rim_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Rim_Drawable	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.modelfileid=1012303
		local scaledivisor=1.23
		self.scale3D=1/scaledivisor	--TODO: probably move to modelinfo
		self.positionmultiplier=POSITION_MULTIPLIER*scaledivisor	--TODO: move to modelinfo		
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo		
	end	
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_ORGOZOA_DribblingIchor_Impact=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Impact
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Impact_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end	
end
do
	local super=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Drawable
	TRAININGGROUNDS_ORGOZOA_DribblingIchor_Impact_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Impact_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.modelfileid=2924468
		self.scale3D=0.5
		self.positionmultiplier=POSITION_MULTIPLIER/0.5
	end	
end