
do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Scenario_ChargedSpear = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Scenario_ChargedSpear

	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:Populate()
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.azshara.groupdancemodule:GetIntoInitialPosition()
		
		
		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(100)		
		local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
		arenaborder:Setup(self.environment.game.environment_gameplay)
		arenaborder.x=0;arenaborder.y=0
		arenaborder:SetSize(platformsize)
		arenaborder.drawable:SetColor(1,1,1,1,.125,.125,.125,1)
	
		
		
		
		--local YDIFF=100
		local XDIFF=125
		--local XDIFF=0
		local YDIFF=100
		
		self.startbuttons={}
		--!!!

		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Hint ghost\rON")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.azshara.groupdancemodule.mode_choice=1
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		

		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Hint ghost\rOFF")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.azshara.groupdancemodule.mode_choice=2
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		

				
		local WardSetup=function(x,y)
			local ward=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Ward01_Decor.new()
			--TODO: ward02,03,04...
			ward:Setup(self.environment.game.environment_gameplay)
			ward.x=x;ward.y=y
			local meter=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_PowerMeter_Decor.new()
			meter:Setup(self.environment.game.environment_gameplay)
			meter.x=x;meter.y=y
		end
		
		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(100)		
		local decorfloor=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Decor_ChargedSpearFloor.new()
		decorfloor:Setup(self.environment.game.environment_gameplay)
		decorfloor.x=0;decorfloor.y=0;decorfloor.z=-yard*5
		--DECORFLOOR=decorfloor
		
		WardSetup(0,-yard*30)
		WardSetup(-yard*22.5,yard*7.5)
		WardSetup(yard*22.5,yard*7.5)
		--WardSetup(0,0)
			

	end

	function class:SetCamera()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		--self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera_AdjustableZoom.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TOdo: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		--local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.azshara=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_BossController_ChargedSpear.new()
		--TOdo: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.azshara:Setup(self.environment.game.environment_gameplay,self)
		self.azshara:CreateBoss()		
		self.azshara.groupdancemodule.bosscontroller=self.azshara
		self.azshara.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.azshara.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	
	function class:PostMove(elapsed)
		super.PostMove(elapsed)
		--TODO: this should be part of ArenaBorder
		if(self.player)then
			local dist=math.sqrt(self.player.x*self.player.x+self.player.y*self.player.y)
			local MAX_DIST=yard*39
			if(dist>MAX_DIST)then
				local unitvectorx=self.player.x/dist
				local unitvectory=self.player.y/dist
				self.player.x=unitvectorx*MAX_DIST
				self.player.y=unitvectory*MAX_DIST
			end
		end
		if(self.player and self.azshara and self.azshara.statues)then
			for i=1,#self.azshara.statues do
				local statue=self.azshara.statues[i]
				local distx=(self.player.x-statue.x)
				local disty=(self.player.y-statue.y)
				local dist=math.sqrt(distx*distx+disty*disty)
				local MIN_DIST=yard*6
				if(dist<MIN_DIST)then
					local unitvectorx=distx/dist
					local unitvectory=disty/dist
					self.player.x=statue.x+unitvectorx*MIN_DIST
					self.player.y=statue.y+unitvectory*MIN_DIST
				end
			end			
		end
		if(self.player and self.prevplayerx and self.azshara and self.azshara.console)then
			local console=self.azshara.console
			local distx=math.abs(self.player.x-console.x)
			local disty=math.abs(self.player.y-console.y)
			if(distx<yard*6.5 and disty<yard*3.5)then
				self.player.x=self.prevplayerx
				self.player.y=self.prevplayery
			end
		end
		if(self.player)then
			self.prevplayerx=self.player.x
			self.prevplayery=self.player.y			
		end
		
	end
	
	
	
end