local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

local function shuffle(list)
	local shuffledlist={unpack(list)}
	for i=#shuffledlist,1,-1 do
		local pos=math.random(i)
		shuffledlist[pos],shuffledlist[i]=shuffledlist[i],shuffledlist[pos]			
	end
	return shuffledlist
end

-- +1: blue
-- -1: green
-- 0: no mark
--TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity=1	-- now set by resetdeathchecks

function TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRaid(gdm)
	local raid=gdm.raid
	TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRoleGroup(raid.tanks)
	TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRoleGroup(raid.rdps)
	TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRoleGroup(raid.mdps)
	TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRoleGroup(raid.healers)	
	-- player is the only raider in "healer" role and gets random mark
	
	--TRAININGGROUNDS_SIVARA_Aura_ClearAllMarks(gdm.player)	
	--print("PLAYER polarity:",TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity)
	--TRAININGGROUNDS_SIVARA_Aura_AssignMarkToRaider(TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity,gdm.player)
end
function TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRoleGroup(group)
	local marks={}
	for i=1,#group do
		tinsert(marks,TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity)		
		TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity=-TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity
		--print("New polarity:",TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity)
	end	
	marks=shuffle(marks)
	for i=1,#group do
		TRAININGGROUNDS_SIVARA_Aura_AssignMarkToRaider(marks[i],group[i])
	end
end
function TRAININGGROUNDS_SIVARA_Aura_AssignMarkToRaider(polarity,raider)
	local auraclass
	--print("Polarity:",polarity)
	if(polarity==1)then
		auraclass=TRAININGGROUNDS_SIVARA_Aura_FrostMark
	else
		auraclass=TRAININGGROUNDS_SIVARA_Aura_VenomousBlood
	end
	raider.combat:ApplyAuraByClass(auraclass,raider.combat)	
end
function TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(raider)
	local blue=raider.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_SIVARA_Aura_FrostMark)
	local green=raider.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_SIVARA_Aura_VenomousBlood)
	if(#blue>0)then
		return 1
	elseif(#green>0)then
		return -1
	else
		return 0
	end
end
function TRAININGGROUNDS_SIVARA_Aura_ClearAllMarks(raider)
	-- REMINDER: this won't find marks in the newauras list!
	local blue=raider.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_SIVARA_Aura_FrostMark)
	local green=raider.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_SIVARA_Aura_VenomousBlood)
	for i=1,#blue do
		--print("Killing blue")
		blue[i]:Die()
	end
	for i=1,#green do
		--print("Killing green")
		green[i]:Die()
	end
end

function TRAININGGROUNDS_SIVARA_Aura_GetRandomNonPlayerRaidersFromRoleGroup(gdm,group,targetpolarity,count)
	local eligibleraiders={}
	for i=1,#group do
		local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(group[i])
		if(polarity==targetpolarity and group[i]~=gdm.player)then
			tinsert(eligibleraiders,group[i])
		end
	end
	eligibleraiders=shuffle(eligibleraiders)
	local result={}
	for i=1,count do
		if(eligibleraiders[i])then
			tinsert(result,eligibleraiders[i])
		end
	end
	return result
end





function TRAININGGROUNDS_SIVARA_Aura_MoveRaidersIntoPosition(gdm)
	local raid=gdm.raid
	for i=1,#raid.players do
		TRAININGGROUNDS_SIVARA_MoveIndividualRaiderIntoPosition(gdm,raid.players[i])
	end
	-- TRAININGGROUNDS_SIVARA_MoveRoleGroupIntoPosition(gdm,raid.tanks,yard*2.5,yard*25,yard*0.25)
	-- TRAININGGROUNDS_SIVARA_MoveRoleGroupIntoPosition(gdm,raid.healers,yard*10,yard*7,yard*7)
	-- TRAININGGROUNDS_SIVARA_MoveRoleGroupIntoPosition(gdm,raid.mdps,yard*6,yard*17,yard*3)	
	-- TRAININGGROUNDS_SIVARA_MoveRoleGroupIntoPosition(gdm,raid.rdps,yard*10,yard*7,yard*7)
	
end

-- function TRAININGGROUNDS_SIVARA_MoveRoleGroupIntoPosition(gdm,group,x,y,precision)
	-- for i=1,#group do
		-- local raider=group[i]
		-- if(raider~=gdm.player)then
			-- local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(raider)
			-- raider.ai:SetTargetLocationAndPrecision({x=x*-polarity,y=y},precision)
		-- end
	-- end
-- end

function TRAININGGROUNDS_SIVARA_MoveIndividualRaiderIntoPosition(gdm,raider)
	local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(raider)
	local x,y,precision
	local role=raider.role
	if(role==1)then
		x=yard*2.5;y=yard*25;precision=yard*0.25
	elseif(role==2)then
		x=yard*10;y=yard*7;precision=yard*7
	elseif(role==3)then
		x=yard*6;y=yard*17;precision=yard*3
	elseif(role==4)then
		x=yard*10;y=yard*7;precision=yard*7
	end
	raider.ai:SetTargetLocationAndPrecision({x=x*-polarity,y=y},precision)
	
end







do
	local super=TRAININGGROUNDS_Aura
	TRAININGGROUNDS_SIVARA_Aura_VenomousBlood=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Aura_VenomousBlood
	function class:SetCustomInfo()
		super.SetCustomInfo(self)		
		self.intensity=1
	end
end

do
	local super=TRAININGGROUNDS_Aura_Snare
	TRAININGGROUNDS_SIVARA_Aura_FrostMark=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Aura_FrostMark
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.percent=1
		self.intensity=1
	end	
	function class:GetPercent()
		local PER_INTENSITY=0.05
		return self.percent-self.intensity*PER_INTENSITY
	end		
end
do
	local super=TRAININGGROUNDS_Aura_Snare
	TRAININGGROUNDS_SIVARA_Aura_StunnedMark=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Aura_StunnedMark
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.baseduration=5.0
	end
	function class:GetPercent()
		return 0
	end		
end

do
	local super=TRAININGGROUNDS_Sprite
	TRAININGGROUNDS_SIVARA_Sprite_Marks=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Sprite_Marks
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		-- must set groupdancemodule after calling setup
		self.groupdancemodule=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite.new()		
		self.drawable:Setup(self,self.environment)
		self.drawable.ystretch=false
		self.drawable.width=100;self.drawable.height=100	
		self.drawable.frame.texture:Show()
		--self.drawable.frame.texture:SetTexture("interface\\icons\\inv_misc_frostemblem_01.blp")
		self.drawable.frame.fontstring:Show()
		self.drawable.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",48,"OUTLINE")
		self.drawable.frame.fontstring:SetText("")
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraph
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		local intensity=""
		if(self.groupdancemodule and self.groupdancemodule.player)then
			local player=self.groupdancemodule.player
			local blue=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_SIVARA_Aura_FrostMark)
			local green=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_SIVARA_Aura_VenomousBlood)
			if(#blue>0)then
				self.visible=true
				self.drawable.frame.texture:SetTexture("interface\\icons\\inv_misc_frostemblem_01.blp")
				intensity=tostring(blue[1].intensity)
			elseif(#green>0)then
				self.visible=true
				self.drawable.frame.texture:SetTexture("interface\\icons\\spell_yorsahj_bloodboil_greenoil.blp")
				intensity=tostring(green[1].intensity)
			else
				self.visible=false
			end
		end			
		--self.drawable.frame.fontstring:SetText(intensity)
	end
end


do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SIVARA_MarksMeter=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_MarksMeter
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.groupdancemodule=nil
		self.energy=0
		self.cooldown=false
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SIVARA_MarksMeter_Drawable.new()		
		self.drawable:Setup(self,self.environment)
		self.drawable.ystretch=false
	end	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		local player=self.groupdancemodule.player
		if(player)then
			local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(player)
			if(polarity~=0)then
				self.visible=true
				local moving=false
				local espeed=0
				if(player.xspeed~=0 or player.yspeed~=0 or player.zspeed~=0)then
					moving=true
				end	
				if(not self.cooldown)then
					if(polarity==1 and moving)then
						espeed=-15
					elseif(polarity==1 and not moving)then
						espeed=5
					elseif(polarity==-1 and (moving and player.z<=0))then
						espeed=15	-- we're not totally confident about this, maybe 20 is more accurate
					elseif(polarity==-1 and not moving)then
						espeed=-5
					else
						espeed=-5
					end
				else
					espeed=-15
				end
				self.energy=self.energy+espeed*elapsed
				if(self.energy<0)then 
					self.energy=0 
					self.cooldown=false
				end
				if(self.energy>=100)then
					self.energy=100
					player.combat:ApplyAuraByClass(TRAININGGROUNDS_SIVARA_Aura_StunnedMark,player.combat)	
					self.cooldown=true
				end
				color=polarity
				if(self.cooldown)then color=2 end
				self.drawable:SetEnergyBarWidth(self.energy,color)
			else
				self.visible=false
			end
		end
	end
end
do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_SIVARA_MarksMeter_Drawable=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_MarksMeter_Drawable
	function class:CreateFrame()		
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()		
		self.frames={}
		tinsert(self.frames,self.frame)
		self.backfill=TRAININGGROUNDS_ReusableFrames:GetFrame()		
		tinsert(self.frames,self.backfill)
		self.barfill=TRAININGGROUNDS_ReusableFrames:GetFrame()		
		tinsert(self.frames,self.barfill)		
	end	
	function class:SetFrameAppearance()
		self.width=200
		self.height=40
		self.frame.texture:Show()
		self.frame.texture:SetColorTexture(1,1,1,1)
		--TODO: width/height should go here, but should we move SetParent+SetPoint somewhere else?
		for i=1,#self.frames do
			--TODO: backfill should appear in front of self.frame...
			self.backfill:SetParent(self.frame)
			self.backfill:SetPoint("TOPLEFT",self.frame,"TOPLEFT",4,-4)
			self.backfill:SetPoint("BOTTOMRIGHT",self.frame,"BOTTOMRIGHT",-4,4)
			self.backfill.texture:Show()
			self.backfill.texture:SetColorTexture(0,0,0,1)
			self.barfill:SetParent(self.frame)
			self.barfill:SetPoint("TOPLEFT",self.frame,"TOPLEFT",4,-4)
			self.barfill:SetPoint("BOTTOMLEFT",self.frame,"BOTTOMLEFT",4,4)
			--self.barfill:SetPoint("BOTTOMRIGHT",self.frame,"BOTTOMRIGHT",-4,4)
			self.barfill.texture:Show()
			self.barfill.texture:SetColorTexture(0.2,0.2,1,1)			
		end
	end
	function class:SetEnergyBarWidth(energy,polarity)
		local maxwidth=200-8
		local width=maxwidth*(energy/100.0)
		if(width<1)then width=1 end
		self.barfill:SetWidth(width)
		if(polarity==1)then
			self.barfill.texture:SetColorTexture(0.2,0.2,1,1)
		elseif(polarity==-1)then
			self.barfill.texture:SetColorTexture(0,1,0,1)
		elseif(polarity==2)then
			self.barfill.texture:SetColorTexture(1,0,0,1)
		end
	end
	function class:SetFrameLevel()
		self.frame:SetFrameLevel(self.framelayer.level)		
		self.backfill:SetFrameLevel(self.framelayer.level+1)
		self.barfill:SetFrameLevel(self.framelayer.level+2)
	end
end


function TRAININGGROUNDS_SIVARA_Aura_CallPlayerMark(gdm)
	local player=gdm.player
	local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(player)
	local iconsize="20"
	local icon,link,message
	if(polarity==1)then
	--if(true)then
		local BLUESQUARE="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_6:12\124t"
		icon="\124Tinterface\\icons\\inv_misc_frostemblem_01:"..iconsize.."\124t"
		link="\124cffff0000\124Hspell:294711\124h[Frost Mark]\124h\124r"			
		message=icon..""..link.." -- move to "..BLUESQUARE.." side and keep moving to avoid freezing"
	elseif(polarity==-1)then
		local GREENTRIANGLE="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_4:12\124t"
		icon="\124Tinterface\\icons\\ability_creature_disease_02:"..iconsize.."\124t"
		link="\124cffff0000\124Hspell:294715\124h[Toxic Brand]\124h\124r"			
		message=icon..""..link.." -- move to "..GREENTRIANGLE.." side and stand still to avoid delirium"		
	end

	TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
	--TRAININGGROUNDS_FakeDBM_RaidBossEmote("call mark",2.0,false)
end