local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

function TRAININGGROUNDS_SIVARA_Spear_Emote(gdm,speartarget)
	local targetpolarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(speartarget)
	local iconsize="20"
	local icon,link
	
	if(targetpolarity==1)then
	--hit target with OPPOSITE javelin				
		icon="\124Tinterface\\icons\\inv_staff_53:"..iconsize.."\124t"
		link="\124cffff0000\124Hspell:295705\124h[Toxic Javelin]\124h\124r"
	else
		icon="\124Tinterface\\icons\\inv_polearm_2h_misc_spearfishingrod:"..iconsize.."\124t"
		link="\124cffff0000\124Hspell:295704\124h[Frost Javelin]\124h\124r"	
	end
	
	local playername="Someone"
	if(speartarget==gdm.player)then
		playername=GetUnitName("player")
	end
	local message=icon.." "..playername.." has been targeted for "..link.."!"
	TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
end

function TRAININGGROUNDS_SIVARA_Spear_SendSpearTargetAndRescuers(gdm,speartarget)
	-- pick 2 random players from mdps group with opposite polarity of speartarget
	local targetpolarity=-TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(speartarget)
	
	local rescuers=TRAININGGROUNDS_SIVARA_Aura_GetRandomNonPlayerRaidersFromRoleGroup(gdm,gdm.raid.mdps,targetpolarity,2)
	for i=1,#rescuers do
		rescuers[i].ai:SetTargetLocationAndPrecision({x=0,y=yard*14},yard*2)
		rescuers[i].spearmarked=true
	end
	--print("Speartarget:",speartarget)
	speartarget.ai:SetTargetLocationAndPrecision({x=0,y=yard*8},yard*2)
	speartarget.spearmarked=true
end


function TRAININGGROUNDS_SIVARA_Spear_RecallSpearTargetAndRescuers(gdm)
	for i=1,#gdm.raid.players do
		local raider=gdm.raid.players[i]
		if(raider.spearmarked)then
			raider.spearmarked=false
			TRAININGGROUNDS_SIVARA_MoveIndividualRaiderIntoPosition(gdm,raider)
		end
	end
end


function TRAININGGROUNDS_SIVARA_Spear_SetupArrow(gdm,speartarget)
	local arrow=TRAININGGROUNDS_SIVARA_Spear_Arrow.new()
	arrow:Setup(gdm.environment)
	arrow.gdm=gdm
	arrow.speartarget=speartarget
	arrow.polarity=-TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(speartarget)
	if(arrow.polarity==1)then
		arrow.drawable:SetColor(0.75,0.75,1,1)
	else
		arrow.drawable:SetColor(0.25,1,0.25,1)
	end
	arrow.expirytime=gdm.environment.localtime+3.5
end

do
	local super=TRAININGGROUNDS_Telegraph_MovementArrow
	TRAININGGROUNDS_SIVARA_Spear_Arrow=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Spear_Arrow


	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		
		self.visible=true
		self.drawable.visible=true
		local x=self.gdm.sivara.x
		local y=self.gdm.sivara.y
		local dist=yard*10
		local angle=math.atan2(self.speartarget.y-y,self.speartarget.x-x)
		self.drawable:SetArrow(x,y,x+math.cos(angle)*dist,y+math.sin(angle)*dist,10,15)
	end
	

end