--TODO: make this a global function already...
local function shuffle(list)
	local shuffledlist={unpack(list)}
	for i=#shuffledlist,1,-1 do
		local pos=math.random(i)
		shuffledlist[pos],shuffledlist[i]=shuffledlist[i],shuffledlist[pos]			
	end
	return shuffledlist
end

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local SKULL="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:12\124t"
	local PURPLEDIAMOND="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_SIVARA_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_SIVARA_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_SIVARA_CustomDanceEventType.CRUSHINGREVERBERATION_CLEAVE=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_SIVARA_GroupDanceModule_Sivara=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_GroupDanceModule_Sivara
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.mode_choice=nil
		self.playerisdead=false
		self.overflowcounter=0
		self.barragecounter=0
		self.spearcounter=0
		self.currenttankindex=1
		self.overflowvoidzones={}
	end


	
	function class:PopulateDefaultRaid(environment)		
		self.environment=environment

		self.sivara=self.bosscontroller.sivara	
		self.sivara.groupdancemodule=self
	
		self.raid:CreatePlayers(environment,2,1,6,12)
		self.raid.rdps[1]:SetRandomAppearance()
		self.raid.healers[1].drawable.frame:SetUnit("player")
		self.raid:MakeAllPlayersIrrelevant()
		for i=1,#self.raid.players do
			self.raid.players[i].currentfacing=math.pi/2	-- facing "north" for 3D camera
		end		
		
		-- -- for now, no autocasts.
		-- for i=1,#self.raid.players do
			-- self.raid.players[i].combat.autocastmodule:Cleanup()
			-- self.raid.players[i].combat.autocastmodule=nil
		-- end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.healers[1]

		--mark melee/ranged players so they know their own role
		--TODO: handle this more gracefully
		for i=1,#self.raid.tanks do
			self.raid.tanks[i].role=1
		end
		for i=1,#self.raid.healers do
			self.raid.healers[i].role=2
		end
		for i=1,#self.raid.mdps do
			self.raid.mdps[i].role=3
		end
		for i=1,#self.raid.rdps do
			self.raid.rdps[i].role=4
		end		
		
		self.centercircles={}
		
		local markicon=TRAININGGROUNDS_SIVARA_Sprite_Marks.new()
		markicon:Setup(self.environment.game.environment_hud)
		--timer:Setup(self.environment)
		markicon.x=-25-50+self.environment.game.SCREEN_WIDTH
		markicon.y=-100-25+self.environment.game.SCREEN_HEIGHT		
		markicon.groupdancemodule=self
		local marksmeter=TRAININGGROUNDS_SIVARA_MarksMeter.new()
		marksmeter:Setup(self.environment.game.environment_hud)
		--timer:Setup(self.environment)
		marksmeter.x=0+self.environment.game.SCREEN_WIDTH/2
		marksmeter.y=-100-50+self.environment.game.SCREEN_HEIGHT/2
		marksmeter.groupdancemodule=self		

							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.sivara.x=yard*0
		self.sivara.y=yard*20
	
		
		self.player.x=0
		self.player.y=yard*5
		--self.player.y=0--!!!
		
		--self.player.currentfacing_3D=self.player.currentfacing
		--self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing

		-- --!!!
		-- self.floor.x=self.player.x
		-- self.floor.y=self.player.y
		-- self.scenario.TEMPfloor=self.floor
		self.scenario.player=self.player
		self.player.groupdancemodule=self
		

		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
		wmcontroller:PlaceWorldMarker(1,-yard*10,yard*10)
		wmcontroller:PlaceWorldMarker(2,yard*10,yard*10)
		wmcontroller:PlaceWorldMarker(8,0,yard*30)
		wmcontroller:PlaceWorldMarker(3,0,yard*10)		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		self:ResetPlayerDeathChecks()
		self.player.drawable.frame:SetUnit("player")
		-- self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_SIVARA_Aura_FrozenSeas,self.player.combat)
		-- local chill=self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_SIVARA_Aura_ChillingTouch,self.player.combat)

			
		local TIME_OFFSET=0	
		--local TIME_OFFSET=-(43.0)
		
		------------- initial marks
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		--totaltime=TIME_OFFSET+0.5
		totaltime=0.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 					
								TRAININGGROUNDS_SIVARA_Aura_AssignRandomMarksToRaid(self)
							end;tinsert(self.timedevents,event)	
		end		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		--totaltime=TIME_OFFSET+2.5
		totaltime=1.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 					
								TRAININGGROUNDS_SIVARA_Aura_CallPlayerMark(self)
								TRAININGGROUNDS_SIVARA_Aura_MoveRaidersIntoPosition(self)
							end;tinsert(self.timedevents,event)	
		end		
	
		----------- crushing reverberation
		local totaltime=0
		local crushing_reverb_times={10.0,34.0,60.0+0.0,60.0+27.0,120.0+8.0,120.0+32.0}
		for i=1,#crushing_reverb_times do
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+crushing_reverb_times[i]
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 	
							local iconsize="20"
							local icon="\124Tinterface\\icons\\spell_nature_earthquake:"..iconsize.."\124t"
							local link="\124cffff0000\124Hspell:295332\124h[Crushing Reverberation]\124h\124r"			
							local message=icon..""..link.." -- knockback"								
							TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
							TEMP_CastSpellOnTargetMobile(self.sivara,TRAININGGROUNDS_SIVARA_Spell_CrushingReverberation,nil)
						end;tinsert(self.timedevents,event)	
			end		
			-- after knockback, move back into position
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
					-- (+3 seconds -- 2 second cast, 1 second reaction time)
			totaltime=TIME_OFFSET+crushing_reverb_times[i]+3
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 	
							TRAININGGROUNDS_SIVARA_Aura_MoveRaidersIntoPosition(self)
						end;tinsert(self.timedevents,event)	
			end				
		end
		
		------------------ overflow
		local totaltime=0
		--TODO: surely there are more than 3 overflows...??
		local overflow_times={16.0,60.0+3.0,60.0+34.0}
		for i=1,#overflow_times do
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+overflow_times[i]
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 	
							local iconsize="20"
							local icon="\124Tinterface\\icons\\sha_ability_warrior_bloodnova_nightmare:"..iconsize.."\124t"
							local link="\124cffff0000\124Hspell:295346\124h[Overflow]\124h\124r"			
							local message=icon..""..link.." -- drop at edge of room"	
							TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
							TRAININGGROUNDS_SIVARA_Overflow_AssignRandomOverflowToRaid(self)
						end;tinsert(self.timedevents,event)	
			end		
			-- during overflow, move into position
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
					-- (1 second reaction time)
			totaltime=TIME_OFFSET+overflow_times[i]+1
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 	
						TRAININGGROUNDS_SIVARA_Overflow_MoveOverflowCPUsToDropoffPoints(self)
					end;tinsert(self.timedevents,event)					
			end		
			-- AFTER overflow, move back to position
			
		end
		
		
		
		------------------ overwhelming barrage
		local totaltime=0
		local barrage_times={40.0,60+20.0,120+0.0,120+40.0}
		for i=1,#barrage_times do		
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+barrage_times[i]-3.0
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 				
					self.barragecounter=self.barragecounter+1
					local iconsize="20"
					local icon="\124Tinterface\\icons\\hunter_pvp_vipersting:"..iconsize.."\124t"
					local link="\124cffff0000\124Hspell:295138\124h[Overwhelming Barrage]\124h\124r"								
					local marker
					-- move tanks "south" for even barrages
					if(self.barragecounter%2==1)then
						marker=SKULL
					else
						marker=PURPLEDIAMOND
						TRAININGGROUNDS_SIVARA_TanksToREDX(self)
					end						
					local message=icon..""..link.." #"..tostring(self.barragecounter).." -- face boss toward "..marker
					TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)					
				end;tinsert(self.timedevents,event)
			end
	
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+barrage_times[i]
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function()
					TRAININGGROUNDS_SIVARA_StartBarrage(self)
				end;tinsert(self.timedevents,event)
			end				
			
			-- then move tanks back into position if it was an even barrage
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+barrage_times[i]+5.0
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 	
					if(self.barragecounter%2==0)then				
						for i=1,#self.raid.tanks do
							local raider=self.raid.tanks[i]
							TRAININGGROUNDS_SIVARA_MoveIndividualRaiderIntoPosition(self,raider)
						end
					end
				end;tinsert(self.timedevents,event)
			end
		end
		
		
		
		
		------------------ frostshock bolts
		--pick a random raider from rdps group OR pick player
		--don't pick someone who's already been targeted
		-- ...we kinda phoned it in at this point, not going to worry about "50% chance to target player"
		local speartargets={unpack(self.raid.rdps)}		
		tinsert(speartargets,self.player)	
		speartargets=shuffle(speartargets)
		-- this will work as long as there are at least 8 raiders in rdps group
		
		
		
		local totaltime=0
		local spear_times={47.0,51.5,56.0,
							60+49.0,60+53.5,60+58.0,
							120+49.0,120+53.5,120+58.0}				
		for i=1,#spear_times do
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+spear_times[i]
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 		
					self.spearcounter=self.spearcounter+1
					local speartarget=speartargets[self.spearcounter]					
					TRAININGGROUNDS_SIVARA_Spear_Emote(self,speartarget)
					TRAININGGROUNDS_SIVARA_Spear_SetupArrow(self,speartarget)
				end;tinsert(self.timedevents,event)
			end
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+spear_times[i]+1
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 		
					local speartarget=speartargets[self.spearcounter]
					TRAININGGROUNDS_SIVARA_Spear_SendSpearTargetAndRescuers(self,speartarget)					
				end;tinsert(self.timedevents,event)
			end			
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+spear_times[i]+4
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 		
					TRAININGGROUNDS_SIVARA_Spear_RecallSpearTargetAndRescuers(self)					
				end;tinsert(self.timedevents,event)
			end			
		end
		
		
		
		
		
		
		
		
		
		
		------------------ inversion
		local totaltime=0
		local inversion_times={60+33.0,180+6.0}		
		for i=1,#inversion_times do		
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+inversion_times[i]-2.25
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 				
				local iconsize="20"
				local icon="\124Tinterface\\icons\\achievement_guildperk_quick and dead:"..iconsize.."\124t"
				local link="\124cffff0000\124Hspell:295791\124h[Inversion]\124h\124r"			
				local message=icon..""..link.." -- spread out"	
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)					
				end;tinsert(self.timedevents,event)
			end
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+inversion_times[i]
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 				
					self.oldplayerpolarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(self.player)
					TRAININGGROUNDS_SIVARA_Inversion_AssignRandomInversionToRaid(self)
				end;tinsert(self.timedevents,event)
			end
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=TIME_OFFSET+inversion_times[i]+5.0
			if(totaltime>0)then
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 	
					local newpolarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(self.player)
					if(newpolarity~=self.oldplayerpolarity)then
						TRAININGGROUNDS_SIVARA_Aura_CallPlayerMark(self)
					end
				end;tinsert(self.timedevents,event)
			end			
			
		end
		
		
		------------------- end
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=TIME_OFFSET+193.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 					
								TRAININGGROUNDS_FakeDBM_RaidBossEmote("(There is no video footage after this point...)",2.0,false)
							end;tinsert(self.timedevents,event)	
		end			
		
		--clear void zones (via resetdeathchecks)
		--clear all auras (from ALL raiders)
		--buttons reappear
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=TIME_OFFSET+196.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 					
								self:ResetPlayerDeathChecks()
								for i=1,#self.raid.players do
									TRAININGGROUNDS_SIVARA_Aura_ClearAllMarks(self.raid.players[i])
								end
								self.scenario:ShowButtons()
							end;tinsert(self.timedevents,event)	
		end				
		
		
		
		
	end
	
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
		self.overflowcounter=0
		self.barragecounter=0
		self.spearcounter=0
		self.currenttankindex=1
		if(math.random()>0.5)then
			TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity=1
		else
			TRAININGGROUNDS_SIVARA_Aura_MarkAssignmentPolarity=-1
		end
		for i=1,#self.overflowvoidzones do
			self.overflowvoidzones[i]:Die()
		end
		self.overflowvoidzones={}
	end
	
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		if(self.currenttankindex)then
			local tank=self.raid.tanks[self.currenttankindex]
			local angle=math.atan2(tank.y-self.sivara.y,tank.x-self.sivara.x)			
			self.sivara.currentfacing=angle
		end
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		-- mobile_fakemonkboss doesn't check whether it's hitting primary player, so check now
		if(event.source~=self.raid.players[1].combat)then return end
		
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		-- local targetcombat=event.target
		-- local targetmobile=nil
		-- if(targetcombat)then targetmobile=targetcombat.owner end
		-- local camera=self.multisidedstrike.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_SIVARA_CustomDanceEventType.MISC_FAILURE)then
			--print("flash")
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		end
	end

	
	-- function class:Arrow(x1,y1,x2,y2,width,radius,R,G,B,A,lifespan)
		-- if(self.mode_choice==2)then return nil end
		-- local testarrow=TRAININGGROUNDS_Telegraph_MovementArrow.new()
		-- testarrow:Setup(self.environment.game.environment_gameplay)
		-- --TODO: should testarrow itself have SetArrow which calls drawable:SetArrow?
				-- -- (in a perfectly encapsulated world, the answer is obviously yes)
		-- testarrow.drawable:SetColor(R,G,B,A)
		-- testarrow.drawable:SetArrow(x1,y1,x2,y2,width,radius)
		-- testarrow.visible=true
		-- testarrow.drawable.visible=true
		-- testarrow.expirytime=self.environment.localtime+lifespan
		-- --TRAININGGROUNDS_FrameVisibilityCheck(testarrow.drawable.frame)
		-- tinsert(self.arrows,testarrow)
		
		-- return testarrow
	-- end
	-- function class:ClearArrows()
		-- for i=1,#self.arrows do
			-- self.arrows[i]:Die()
		-- end
	-- end
	
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
