local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

function TRAININGGROUNDS_SIVARA_Inversion_AssignRandomInversionToRaid(gdm)
	local targetplayer=false
	if(math.random()<0.5)then targetplayer=true end	
	
	-- randomly pick 2 each (2 per color) from mdps and 3 each from rdps
	-- if player is targeted and in same group, subtract 1 from random pick count
	local playergroup,playerpolarity=TRAININGGROUNDS_SIVARA_Overflow_DeterminePlayerGroup(gdm)
	
	TRAININGGROUNDS_SIVARA_Inversion_AttemptAssignRandomInversionToRoleGroup(gdm,gdm.raid.mdps,1,playergroup,playerpolarity,targetplayer,1)
	TRAININGGROUNDS_SIVARA_Inversion_AttemptAssignRandomInversionToRoleGroup(gdm,gdm.raid.mdps,-1,playergroup,playerpolarity,targetplayer,1)
	TRAININGGROUNDS_SIVARA_Inversion_AttemptAssignRandomInversionToRoleGroup(gdm,gdm.raid.rdps,1,playergroup,playerpolarity,targetplayer,2)
	TRAININGGROUNDS_SIVARA_Inversion_AttemptAssignRandomInversionToRoleGroup(gdm,gdm.raid.rdps,-1,playergroup,playerpolarity,targetplayer,2)
	if(targetplayer)then
		TRAININGGROUNDS_SIVARA_Inversion_InvertRaider(gdm.player)
	end
	
	TRAININGGROUNDS_SIVARA_Inversion_InvertPools(gdm)
	
end

function TRAININGGROUNDS_SIVARA_Inversion_AttemptAssignRandomInversionToRoleGroup(gdm,group,polarity,playergroup,playerpolarity,targetplayer,count)
	if(TRAININGGROUNDS_SIVARA_Overflow_CheckGroupOKWithPlayerTarget(gdm,group,polarity,playergroup,playerpolarity,targetplayer)==false)then
		count=count-1
	end
	local raiders=TRAININGGROUNDS_SIVARA_Aura_GetRandomNonPlayerRaidersFromRoleGroup(gdm,group,polarity,count)
	for i=1,#raiders do
		local raider=raiders[i]
		TRAININGGROUNDS_SIVARA_Inversion_InvertRaider(raider)
	end
end

function TRAININGGROUNDS_SIVARA_Inversion_InvertRaider(raider)
	local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(raider)
	TRAININGGROUNDS_SIVARA_Aura_ClearAllMarks(raider)
	if(polarity~=0)then
		TRAININGGROUNDS_SIVARA_Aura_AssignMarkToRaider(-polarity,raider)
	end
	
	raider.combat:ApplyAuraByClass(TRAININGGROUNDS_SIVARA_Inversion_Aura,raider.combat)	
end

do
	local super=TRAININGGROUNDS_Aura_Snare
	TRAININGGROUNDS_SIVARA_Inversion_Aura=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Inversion_Aura
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.baseduration=5.0
	end
	function class:GetPercent()
		return 0
	end		

	function class:OnApply(combattime)
		--TODO: "auraradius" might become a reserved word in future
		--print("OnApply (0)")
		self.auraradius=4
		self:ApplyTelegraph()	
		self.targetcombat.owner.inversionmarked=true
	end
	
	function class:OnExpiry()	
		super.OnExpiry(self)		
		self.targetcombat.owner.inversionmarked=false
		local gdm=self.targetcombat.owner.environment.game.scenario.gdm
		--check if overflowmarked before trying to move into new position
		if(self.targetcombat.owner.overflowmarked~=true)then
			TRAININGGROUNDS_SIVARA_MoveIndividualRaiderIntoPosition(gdm,self.targetcombat.owner)
		end
	end
	
	function class:ApplyTelegraph()
		local targetmobile=self.targetcombat.owner
		local telegraph=TRAININGGROUNDS_Telegraph_BigThinCircle_Flash.new()		
		local x1=targetmobile.x
		local y1=targetmobile.y
		telegraph:Setup(targetmobile.environment)		
		telegraph.x=x1
		telegraph.y=y1
			--TODO: expires on next tick
		telegraph.expirytime=targetmobile.environment.localtime+5.0
		telegraph.flashperiod=1.1
		telegraph:SetColor(0.25,0.25,0.25,1)
		telegraph:ChangeFrameLayer(targetmobile.environment.cameramanager.camera.voidzoneframelayer)		
		telegraph.lockonmobile=targetmobile		
		telegraph:SetRadius(TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(self.auraradius))
	end
	
	function class:ApplyDamageEffect()
		local targetmobile=self.targetcombat.owner		
		local telegraph=TRAININGGROUNDS_Telegraph_Circle_FlashOnce.new()
		telegraph:Setup(targetmobile.environment)		
		local x1=targetmobile.x
		local y1=targetmobile.y		
		telegraph.x=x1
		telegraph.y=y1	
		telegraph:SetColor(1,0,0,1)
		telegraph:SetRadius(TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(self.auraradius))
		
		local players=TRAININGGROUNDS_GetAllObjectsInCircle(
			self.castercombat.owner.environment.mobiles,
			x1,y1,TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(self.auraradius))
		
		--print("Checking for players within radius",x1,y1)
		--print("Found",#players)
		for i=1,#players do			
			if(players[i]~=targetmobile)then
				self.castercombat.combatlog:RecordEvent({
								action=TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK,
								subject=self:Class(),
								target=players[i].combat,
								source=targetmobile.combat
								})
			end
		end
	end	
	
end

function TRAININGGROUNDS_SIVARA_Inversion_InvertPools(gdm)
	for i=1,#gdm.overflowvoidzones do
		gdm.overflowvoidzones[i].polarity=-gdm.overflowvoidzones[i].polarity
	end
end