local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
--TODO LATER: consolidate "rdps" and "healer" groups into a single "ranged" group
function TRAININGGROUNDS_SIVARA_Overflow_AssignRandomOverflowToRaid(gdm)
	gdm.overflowcounter=gdm.overflowcounter+1
	local targetplayer=false
	if(math.random()<0.5)then targetplayer=true end	
	local raid=gdm.raid
	local playergroup,playerpolarity=TRAININGGROUNDS_SIVARA_Overflow_DeterminePlayerGroup(gdm)
	--print("Player target info:",playergroup,playerpolarity,targetplayer)
	if(targetplayer)then
		gdm.player.combat:ApplyAuraByClass(TRAININGGROUNDS_SIVARA_Overflow_Aura,gdm.player.combat)	
	end
	TRAININGGROUNDS_SIVARA_Overflow_AttemptAssignRandomOverflowToRoleGroup(gdm,gdm.raid.mdps,1,playergroup,playerpolarity,targetplayer)
	TRAININGGROUNDS_SIVARA_Overflow_AttemptAssignRandomOverflowToRoleGroup(gdm,gdm.raid.mdps,-1,playergroup,playerpolarity,targetplayer)
	TRAININGGROUNDS_SIVARA_Overflow_AttemptAssignRandomOverflowToRoleGroup(gdm,gdm.raid.rdps,1,playergroup,playerpolarity,targetplayer)
	TRAININGGROUNDS_SIVARA_Overflow_AttemptAssignRandomOverflowToRoleGroup(gdm,gdm.raid.rdps,-1,playergroup,playerpolarity,targetplayer)
end

function TRAININGGROUNDS_SIVARA_Overflow_DeterminePlayerGroup(gdm)
	local group,polarity	
	polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(gdm.player)
	local distx=gdm.sivara.x-gdm.player.x
	local disty=gdm.sivara.y-gdm.player.y
	local distsqr=distx*distx+disty*disty
	local dist=math.sqrt(distsqr)
	if(dist<10*yard)then
		group=gdm.raid.mdps
	else
		group=gdm.raid.rdps
	end
	return group,polarity
end

function TRAININGGROUNDS_SIVARA_Overflow_AttemptAssignRandomOverflowToRoleGroup(gdm,group,polarity,playergroup,playerpolarity,targetplayer)
	-- if player is in same role group AND we're targeting player with something, cancel
	if(TRAININGGROUNDS_SIVARA_Overflow_CheckGroupOKWithPlayerTarget(gdm,group,polarity,playergroup,playerpolarity,targetplayer)==false)then
		return
	end
	local raiders=TRAININGGROUNDS_SIVARA_Aura_GetRandomNonPlayerRaidersFromRoleGroup(gdm,group,polarity,1)
	for i=1,#raiders do
		local raider=raiders[i]
		raider.combat:ApplyAuraByClass(TRAININGGROUNDS_SIVARA_Overflow_Aura,raider.combat)	
	end
end

function TRAININGGROUNDS_SIVARA_Overflow_CheckGroupOKWithPlayerTarget(gdm,group,polarity,playergroup,playerpolarity,targetplayer)
	if(targetplayer==true and polarity==playerpolarity and group==playergroup)then return false end
	return true
end

do
	local super=TRAININGGROUNDS_Aura
	TRAININGGROUNDS_SIVARA_Overflow_Aura=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Overflow_Aura
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.baseduration=6.0
		self.polarity=nil	--1 blue, -1 green
	end
	
	function class:OnApply(combattime)
		--TODO: "auraradius" might become a reserved word in future
		--print("OnApply (0)")
		self.auraradius=5
		self:ApplyTelegraph()	
		self.targetcombat.owner.overflowmarked=true
	end
	
	function class:OnExpiry()	
		super.OnExpiry(self)		
		self.targetcombat.owner.overflowmarked=false
		local gdm=self.targetcombat.owner.environment.game.scenario.sivara.groupdancemodule
		TRAININGGROUNDS_SIVARA_MoveIndividualRaiderIntoPosition(gdm,self.targetcombat.owner)
		--apply voidzone
		voidzone=TRAININGGROUNDS_SIVARA_Overflow_VoidZone.new()
		voidzone:Setup(self.targetcombat.owner.environment)
		voidzone.x=self.targetcombat.owner.x;voidzone.y=self.targetcombat.owner.y
		voidzone.polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(self.targetcombat.owner)
		voidzone.drawable.width=yard*10;voidzone.drawable.height=yard*10
		tinsert(gdm.overflowvoidzones,voidzone)
	end
	
	function class:ApplyTelegraph()
		local targetmobile=self.targetcombat.owner
		local telegraph=TRAININGGROUNDS_Telegraph_BigThinCircle_Flash.new()		
		local x1=targetmobile.x
		local y1=targetmobile.y
		telegraph:Setup(targetmobile.environment)		
		telegraph.x=x1
		telegraph.y=y1
			--TODO: expires on next tick
		telegraph.expirytime=targetmobile.environment.localtime+5.0
		telegraph.flashperiod=1.1
		telegraph:SetColor(0.25,0.25,0.25,1)
		telegraph:ChangeFrameLayer(targetmobile.environment.cameramanager.camera.voidzoneframelayer)		
		telegraph.lockonmobile=targetmobile		
		telegraph:SetRadius(TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(self.auraradius))
	end
	
	function class:ApplyDamageEffect()
		local targetmobile=self.targetcombat.owner		
		local telegraph=TRAININGGROUNDS_Telegraph_Circle_FlashOnce.new()
		telegraph:Setup(targetmobile.environment)		
		local x1=targetmobile.x
		local y1=targetmobile.y		
		telegraph.x=x1
		telegraph.y=y1	
		telegraph:SetColor(1,0,0,1)
		telegraph:SetRadius(TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(self.auraradius))
		
		local players=TRAININGGROUNDS_GetAllObjectsInCircle(
			self.castercombat.owner.environment.mobiles,
			x1,y1,TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(self.auraradius))
		
		--print("Checking for players within radius",x1,y1)
		--print("Found",#players)
		for i=1,#players do			
			if(players[i]~=targetmobile)then
				self.castercombat.combatlog:RecordEvent({
								action=TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK,
								subject=self:Class(),
								target=players[i].combat,
								source=targetmobile.combat
								})
			end
		end
	end	
end


function TRAININGGROUNDS_SIVARA_Overflow_MoveOverflowCPUsToDropoffPoints(gdm)
	for i=1,#gdm.raid.players do
		local raider=gdm.raid.players[i]
		if(raider~=gdm.player)then			
			if(raider.overflowmarked)then
				local role=raider.role
				local baseangle=math.pi/2
				local offsetangle
				if(role==3)then	--mdps
					offsetangle=math.pi*2/8
				else	--rdps
					offsetangle=math.pi*2/16
				end
				local offset2angle=(gdm.overflowcounter-1)*math.pi*2/24
				local dist=yard*29
				local x=dist*math.cos(baseangle+offsetangle+offset2angle)
				local y=dist*math.sin(baseangle+offsetangle+offset2angle)
				if(role==4)then	--rdps
					y=-y
				end
				--x=x*TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(raider)
				x=x*-TRAININGGROUNDS_signum(raider.x)
				raider.ai:SetTargetLocationAndPrecision({x=x,y=y},yard*0.75)
			end
		end
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SIVARA_Overflow_VoidZone=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Overflow_VoidZone
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.hitdetect=true
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite_Circle_Telegraph:new()
		self.drawable:Setup(self,self.environment)
		self.drawable:SetColor(1,1,1,1)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local r,g,b
		if(self.polarity==1)then
			r=0.75;g=0.75;b=1
		else
			r=0.25;g=1;b=0.25
		end
		self.drawable:SetColor(r,g,b,1)
			

	end
end