local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

local function shuffle(list)
	local shuffledlist={unpack(list)}
	for i=#shuffledlist,1,-1 do
		local pos=math.random(i)
		shuffledlist[pos],shuffledlist[i]=shuffledlist[i],shuffledlist[pos]			
	end
	return shuffledlist
end

function TRAININGGROUNDS_SIVARA_TanksToREDX(gdm)
	for i=1,#gdm.raid.tanks do
		local raider=gdm.raid.tanks[i]
		local polarity=TRAININGGROUNDS_SIVARA_Aura_GetRaiderPolarity(raider)
		x=yard*2.5;y=yard*15;precision=yard*0.25
		raider.ai:SetTargetLocationAndPrecision({x=x*-polarity,y=y},precision)
	end
end

function TRAININGGROUNDS_SIVARA_StartBarrage(gdm)	
	local basepolarity=-1
	if(gdm.barragecounter%2==1)then basepolarity=1 end
	TRAININGGROUNDS_SIVARA_8Projectiles(gdm,basepolarity,false,false,1)	
	TRAININGGROUNDS_SIVARA_8Projectiles(gdm,basepolarity,false,true,2)	
	TRAININGGROUNDS_SIVARA_8Projectiles(gdm,-basepolarity,true,false,3)
	TRAININGGROUNDS_SIVARA_8Projectiles(gdm,-basepolarity,true,true,4)
	

end

function TRAININGGROUNDS_SIVARA_8Projectiles(gdm,polarity,reflectx,reflecty,group)
	local baseangle=gdm.sivara.currentfacing
	local deg90=math.pi/2
	local baseoffset=-deg90/14
	local offset=deg90/7
	local shootorder=shuffle({0,1,2,3,4,5,6,7})
	for i=1,8 do
		local angleoffset=baseoffset+offset*(i-1)		
		if(reflecty)then angleoffset=math.pi-angleoffset end
		if(reflectx)then angleoffset=-angleoffset end
		local angle=baseangle+angleoffset
		local dist=yard*7
		local proj=TRAININGGROUNDS_SIVARA_OverwhelmingBarrage_Projectile.new()
		proj:Setup(gdm.sivara.environment)
		proj.x=gdm.sivara.x+math.cos(angle)*dist
		proj.y=gdm.sivara.y+math.sin(angle)*dist
		proj.polarity=polarity		
		proj.angle=angle
		proj.shootorder=shootorder[i]
		proj.group=group
	end	
end

do
	
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SIVARA_OverwhelmingBarrage_Projectile=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_OverwhelmingBarrage_Projectile
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.hitdetect=true
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite_Circle_Telegraph:new()
		self.drawable:Setup(self,self.environment)
		self.drawable:SetColor(1,1,1,1)
		self.drawable.width=50
		self.drawable.height=50
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local r,g,b
		if(self.polarity==1)then
			r=0.75;g=0.75;b=1
		else
			r=0.25;g=1;b=0.25
		end
		self.drawable:SetColor(r,g,b,0.75)
		
		if(self.state==1 and self.alivetime>3+self.shootorder*3/8+self.group*(3/8)/4)then
			self.state=2
			local SPEED=yard*21
			self.xspeed=math.cos(self.angle)*SPEED
			self.yspeed=math.sin(self.angle)*SPEED			
		end
		if(self.alivetime>3+self.shootorder*3/8+5)then self:Die() end

	end
end