
do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_SIVARA_Scenario_Sivara = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Scenario_Sivara

	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:Populate()
		super.Populate(self)				
		
		--TODO: RaidMarkerController should be in baseline scenario class	
		local wmcontroller=TRAININGGROUNDS_RaidMarkerController.new()
		wmcontroller:Setup(self.environment.game.environment_gameplay)
		self.wmcontroller=wmcontroller

		
		self:CreateBossController()
		
		local currentplayer=self.raid.healers[1]
		self.controls:SetPlayer(currentplayer)
		--currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.sivara.groupdancemodule:GetIntoInitialPosition()
		
		
		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(60)		
		local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
		arenaborder:Setup(self.environment.game.environment_gameplay)
		arenaborder.x=0;arenaborder.y=0
		arenaborder:SetSize(platformsize)
		arenaborder.drawable:SetColor(1,1,1,1,.325,.75,.75,1)
	
		
		
		
		--local YDIFF=100
		--local XDIFF=125
		local XDIFF=0
		local YDIFF=0		
		
		self.startbuttons={}
		--!!!

		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Start")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.sivara.groupdancemodule.mode_choice=2
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		

		text=TRAININGGROUNDS_Debug_Text.new();text:Setup(self.environment.game.environment_hud)
		text.x=0+self.environment.game.window.frame:GetWidth()/2;text.y=-100+self.environment.game.window.frame:GetHeight()/2+125
		text.drawable.width=500;text.drawable.height=150
		text:SetText("This is an experimental module based on footage from the PTR.\r"
					.."There are no success or failure conditions.\r"
					.."Boss mechanics are subject to change.")
		tinsert(self.startbuttons,text)		
		
		text=TRAININGGROUNDS_Debug_Text.new();text:Setup(self.environment.game.environment_hud)
		text.x=0+self.environment.game.window.frame:GetWidth()/2;text.y=-100+self.environment.game.window.frame:GetHeight()/2-125-25
		text.drawable.width=500;text.drawable.height=70
		text:SetText("You can adjust the camera with the scroll wheel.")
		tinsert(self.startbuttons,text)
			
			
			

	end

	function class:SetCamera()
		--self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		--self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera.new()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera_AdjustableZoom.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		--local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.sivara=TRAININGGROUNDS_SIVARA_BossController_Sivara.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.sivara:Setup(self.environment.game.environment_gameplay,self)
		self.sivara:CreateBoss()		
		self.sivara.groupdancemodule.bosscontroller=self.sivara
		self.sivara.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.sivara.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	
	function class:PostMove(elapsed)
		super.PostMove(elapsed)
		--print("PostMove",self.player)
		-- if(self.player)then
			-- local dist=math.sqrt(self.player.x*self.player.x+self.player.y*self.player.y)
			-- local MAX_DIST=yard*30
			-- if(dist>MAX_DIST)then
				-- local unitvectorx=self.player.x/dist
				-- local unitvectory=self.player.y/dist
				-- self.player.x=unitvectorx*MAX_DIST
				-- self.player.y=unitvectory*MAX_DIST
			-- end
		-- end
		if(self.sivara)then
			local gdm=self.sivara.groupdancemodule
			for i=1,#gdm.raid.players do
				local raider=gdm.raid.players[i]
				local dist=math.sqrt(raider.x*raider.x+raider.y*raider.y)
				local MAX_DIST=yard*30
				if(dist>MAX_DIST)then
					local unitvectorx=raider.x/dist
					local unitvectory=raider.y/dist
					raider.x=unitvectorx*MAX_DIST
					raider.y=unitvectory*MAX_DIST
				end
			end		
		end
	end

	
	
	
end