
--[[
	Known flash patterns:
	
	1. 4 lines center, bolting port to starboard, then 3 lines stern+bow, bolting starboard to port
	2. 5 lines port, bolting bow to stern, then 5 lines starboard, bolting stern to bow	
	3. 10 short lines stern to bow -- first bolting starboard to port, then alternating
	4. 10 long lines starboard to port -- first bolting stern to bow, then alternating
	5. (mythic only, docks)
	
]]--




local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	function TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup(coordinate,orientation,environment,reversezap,gdm)
		local x1,x2,y1,y2	-- orb placement
		local x0,y0		-- beam placement
		local facing,zaplength
		if(orientation==1)then
			--short beams
			x1,x2=coordinate,coordinate
			y1,y2=-yard*10,yard*10
			x0,y0=coordinate,0
			facing=math.pi/2;zaplength=20		
		elseif(orientation==2)then
			--long beams
			x1,x2=-yard*15,yard*15
			y1,y2=coordinate,coordinate
			x0,y0=0,coordinate
			facing=0;zaplength=30
		elseif(orientation==3)then
			--mythic "half short" position 1
			x1,x2=coordinate,coordinate
			y1,y2=0,yard*20
			x0,y0=coordinate,yard*10
			facing=math.pi/2;zaplength=20
		elseif(orientation==4)then
			--mythic "half short" position 2
			x1,x2=coordinate,coordinate
			y1,y2=-yard*20,0
			x0,y0=coordinate,-yard*10
			facing=math.pi/2;zaplength=20
		end
		if(reversezap)then facing=facing+math.pi end
		local orb=TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Telegraph.new()
		orb:Setup(environment);orb.x=x1;orb.y=y1;orb.expirytime=environment.localtime+2.0
		local orb=TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Telegraph.new()
		orb:Setup(environment);orb.x=x2;orb.y=y2;orb.expirytime=environment.localtime+2.0
		local beam=TRAININGGROUNDS_STORMWALLBLOCKADE_Beam_Telegraph.new()
		beam:Setup(environment);beam.x=x0;beam.y=y0;beam.expirytime=environment.localtime+2.0	
		beam.x1=x1;beam.x2=x2;beam.y1=y1;beam.y2=y2
		beam.zaplength=zaplength
		beam.currentfacing=facing
		beam.gdm=gdm
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Telegraph=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Telegraph
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
		self.ysortable=true --TODO: why isn't this ysorting properly?
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Orb_Drawable
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_zuldazarraid_blockade_katherine_voltaicflash_chargeuporb.m2"		
		self.modelfileid=2503464		
		self.scale3D=0.5/2	--TODO: probably move to modelinfo
		self.positionmultiplier=1*2	--TODO: move to modelinfo
		--self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.5	--TODO: move to modelinfo
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		local newx=self.x
		local newy=self.y
		local newz=self.z+yard*1
		return newx,newy,newz
	end			
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Beam_Telegraph=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Beam_Telegraph
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
		self.ysortable=true
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Beam_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
	function class:OnExpiry(expirytime)
		super.OnExpiry(self,expirytime)
		local zap=TRAININGGROUNDS_STORMWALLBLOCKADE_Zap_Decor.new()
		zap.zaplength=self.zaplength
		zap:Setup(self.environment);zap.x=self.x;zap.y=self.y;zap.expirytime=self.environment.localtime+2.0
		zap.currentfacing=self.currentfacing
		--also, hit detection
		local PLAYERRADIUS=yard*1.5
		local player=self.gdm.player
		if(TRAININGGROUNDS_LineCircleCollision(self.x1,self.y1,self.x2,self.y2,player.x,player.y,PLAYERRADIUS))then
			self.gdm:ReactToCustomDanceEvent({action=TRAININGGROUNDS_STORMWALLBLOCKADE_VOLTAICFLASH_CustomDanceEventType.HIT_BY_VOLTAICFLASH})
		end
	end	
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_STORMWALLBLOCKADE_Beam_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Beam_Drawable
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_zuldazarraid_blockade_katherine_voltaicflash_lightningfocusbeam.m2"
		self.modelfileid=2564705
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=1	--TODO: move to modelinfo
		--self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.5	--TODO: move to modelinfo
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		local newx=self.x
		local newy=self.y
		local newz=self.z-yard*0
		return newx,newy,newz
	end		

end
do
	local super=TRAININGGROUNDS_GameObject	
	TRAININGGROUNDS_STORMWALLBLOCKADE_Zap_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Zap_Decor	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
		self.ysortable=true
	end
	function class:SetDrawable()
		--set zaplength before calling setup!
		if(self.zaplength==20)then
			self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Zap20_Drawable.new()
		else
			self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Zap30_Drawable.new()
		end
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_STORMWALLBLOCKADE_Zap30_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Zap30_Drawable
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_zuldazarraid_blockade_katherine_voltaicflash_bolt_30.m2"
		self.modelfileid=2503465
		--self.modelfilename="spells/8fx_zuldazarraid_blockade_katherine_voltaicflash_bolt_20.m2"
		--self.modelfileid=2503466		
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=1	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.5	--TODO: move to modelinfo
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		local radius=yard*30/2
		local newx=self.x-radius
		local newy=self.y
		local newz=self.z-yard*0
		return newx,newy,newz
	end		
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_STORMWALLBLOCKADE_Zap20_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Zap20_Drawable
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		--self.modelfilename="spells/8fx_zuldazarraid_blockade_katherine_voltaicflash_bolt_30.m2"
		--self.modelfileid=2503465
		self.modelfilename="spells/8fx_zuldazarraid_blockade_katherine_voltaicflash_bolt_20.m2"
		self.modelfileid=2503466		
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=1	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.5	--TODO: move to modelinfo
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		local radius=yard*20/2
		local newx=self.x-radius
		local newy=self.y
		local newz=self.z-yard*0
		return newx,newy,newz
	end		
end