
do
	local super=TRAININGGROUNDS_Camera
	TRAININGGROUNDS_Camera3D = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Camera3D

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		--self.cangx=math.pi/4
		self.cangx=-math.pi/6
		self.cangy=0
		self.cangz=0
		self.clookatx=0
		self.clookaty=0
		self.clookatz=0
		self.cdist=15
		--self.cdist=300--!!!
		
	end
	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:ArrangeAllGameObjects(objs)
	
		if(not self.rot)then self.rot=0 end
		
		if(#self.focus>0)then			
			--TODO: we are ignoring focuses beyond index#1; don't
			self.clookatx=self.focus[1].x/yard
			self.clookaty=self.focus[1].z/yard+1
			self.clookatz=self.focus[1].y/yard
		end
		
		--TODO: camera3D's .y is height but the rest of the game's .z is height.
		--TODO: these distances are already in yards; don't need to convert to TGUnits.  confusing.  make less confusing.
		
		--rotate around origin
		local cposoffsetvectorx,cposoffsetvectory,cposoffsetvectorz=TRAININGGROUNDS_MatrixMultiplicationRotation(0,0,-1,-self.cangx,-self.cangy+math.pi/2,-self.cangz)
		-- translate camera to focus
		-- note that we don't pass these to Drawable due to camera drift shenanigans.
		-- however, we still need to calculate un-shenaniganed camera position for zsort later
		local cposx=cposoffsetvectorx*self.cdist+self.clookatx
		local cposy=cposoffsetvectory*self.cdist+self.clookaty
		local cposz=cposoffsetvectorz*self.cdist+self.clookatz
		
		--print("cangy:",self.cangy,cposx,cposy,coffsetx,coffsety)
		
		--print("cpos:",cposx,cposy,cposz)
		
		
		self:SetScrollAndZoom()  -- this is expected to do nothing
				
		for i=1,#objs,1 do
			local obj=objs[i]		
			--"obj.drawable" is the Drawable to be drawn (i.e. we're checking "does such a drawable exist")
			if(obj.drawable)then
				--"obj.visible" is a property (i.e. we're checking "is this drawn object currently visible")
				
				if(obj.drawable.visible)then
					if(not obj.drawable.frame) then
						error("Object ",obj," drawable ",obj.drawable," does not have a frame (did we forget to run setup?)")
					end				
					--obj.drawable:ArrangeFrame(self.objectanchor,x,y,wid,hgt,yaw,pitch,self.zoom)
					obj.drawable:ArrangeFrame3D(cposoffsetvectorx,cposoffsetvectory,cposoffsetvectorz,self.cdist,self.clookatx,self.clookaty,self.clookatz,self.cangx,self.cangy,self.cangz)

					obj.drawable:ShowFrames()
				else	-- end visible check
				
					obj.drawable:HideFrames()
				end
			end	-- end drawable-exists check
		end		-- end arrange loop
		
		
		--"top layer", not "to player"
		local toplayer=self.ysortframelevel
		local nameplatelayer=self.nameplateframelevel
		if(self.ysort) then	
			--TODO: maybe self.realtime instead of self.game.realtime?			
			if(self.environment.game.realtime>self.nextysorttime)then
				self.nextysorttime=self.environment.game.realtime+self.nextysortinterval
				--TODO: ysorting works differently in 3D
				local tempysort={}
				for i=1,#objs,1 do 
					if(objs[i].ysortable==true)then						
						local xdiff=objs[i].x/yard-cposx
						local ydiff=objs[i].z/yard-cposy		-- remember, cameraY is vertical, objY is depth
						local zdiff=objs[i].y/yard-cposz
						
						--local ignoreX,ignoreY,tempZsort=TRAININGGROUNDS_MatrixMultiplicationRotation(xdiff,ydiff,zdiff,self.cangx,self.cangy,self.cangz)						
						--local ignoreX,ignoreY,tempZsort=TRAININGGROUNDS_MatrixMultiplicationRotation(-xdiff,-ydiff,-zdiff,self.cangx,self.cangy,self.cangz)
						local ignoreX,ignoreY,tempZsort=TRAININGGROUNDS_MatrixMultiplicationRotation(xdiff,ydiff,zdiff,self.cangx,self.cangy+math.pi/2,self.cangz)

						-- print("Distance:",math.sqrt(xdiff*xdiff,ydiff*ydiff,zdiff*zdiff))
						-- print("tempZsort:",tempZsort)
						
						if(objs[i].drawable.zsortoffset3D)then
							-- NEGATIVE offset makes object appear FURTHER from camera
							-- POSITIVE offset makes object appear CLOSER to camera													
							tempZsort=tempZsort+objs[i].drawable.zsortoffset3D*yard										
						end
						objs[i].tempZsort=tempZsort
						
												
						tinsert(tempysort,objs[i]) 					
					end
				end
				table.sort(tempysort, function(a,b) return a.tempZsort<b.tempZsort end)	
				for k,v in ipairs(tempysort) do 						
					toplayer=v.drawable:SetSortedFrameLevels(toplayer)								
				end
				toplayer=256
				for k,v in ipairs(tempysort) do 						
					local n=v.nameplate
					if(n)then
						toplayer=n.drawable:SetSortedFrameLevels(toplayer)
					end
				end				
			end		
		end
		
		if((not self.postysortframelevel) or toplayer>self.postysortframelevel)then self.postysortframelevel=toplayer end
		for i=1,#objs,1 do 
			if(not objs[i].ysortable)then
				if(objs[i].drawable.updateframelevel)then
					objs[i].drawable:SetFrameLevel()
					objs[i].drawable.updateframelevel=false
				end			
			end
		end
	end
	
	function class:SetScrollAndZoom()
		-- do nothing!
		-- don't call super
	end
end