
--TODO: some of these functions should be moved out of default camera

local super=TRAININGGROUNDS_Camera
TRAININGGROUNDS_Camera_AdjustableZoom = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Camera_AdjustableZoom

function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.nudgex=0
	self.nudgey=0
end

--TODO: camera and scenario have their own GetPlayerInput.  should we combine camera+scenario playerinput?
function class:GetPlayerInput(elapsed)
	--TODO NEXT: take a look at zoom controls from old version
	--TODO: camera controls should go in scenariocontrols
	local keys=self.environment.game.keys	
	local delta=keys.wmouse.pressed
	if(delta)then
		self:AdjustZoomViaScrollWheel(delta)
	end	
	--local SCROLL_SPEED=200	
	local SCROLL_SPEED=2000
	local RECALL_SPEED=3000
	if(keys.left.current)then
		self.nudgex=self.nudgex-SCROLL_SPEED*elapsed*(1/self.zoom)
	end
	if(keys.right.current)then
		self.nudgex=self.nudgex+SCROLL_SPEED*elapsed*(1/self.zoom)
	end	
	if(keys.up.current)then
		self.nudgey=self.nudgey+SCROLL_SPEED*elapsed*(1/self.zoom)
	end
	if(keys.down.current)then
		self.nudgey=self.nudgey-SCROLL_SPEED*elapsed*(1/self.zoom)
	end	
	
	local dist=math.sqrt(self.nudgex*self.nudgex+self.nudgey*self.nudgey)
	local olddist=dist
	if(dist>0)then
		local unitvectorx=self.nudgex/dist
		local unitvectory=self.nudgey/dist			
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		local multiplier=math.sqrt(self.zoom)
		if(multiplier>1)then multiplier=1 end
		if(dist>yard*70*(multiplier))then
			dist=yard*70*(multiplier)
		end
		if(not (keys.left.current or keys.right.current or keys.up.current or keys.down.current))then 				
			dist=dist-RECALL_SPEED*elapsed*(1/self.zoom)
			if(dist<0)then dist=0 end
		end
		if(dist~=olddist)then			
			self.nudgex=unitvectorx*dist
			self.nudgey=unitvectory*dist
		end
		
	end
	
	
end

function class:MoveToFocus(elapsed)
--TODO: smoother scrolling

	local keys=self.environment.game.keys	
	

	if(#self.focus==0)then return end
	
	local xmin,ymin,xmax,ymax
	local xtotal=0
	local ytotal=0
	for i=1,#self.focus do
		local focus=self.focus[i]
		if((not xmin) or (xmin>focus.x))then xmin=focus.x end
		if((not xmax) or (xmax<focus.x))then xmax=focus.x end
		if((not ymin) or (ymin>focus.y))then ymin=focus.y end
		if((not ymax) or (ymax<focus.y))then ymax=focus.y end
		xtotal=xtotal+focus.x
		ytotal=ytotal+focus.y
	end
	local extra=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(5)
	xmin=xmin-extra
	ymin=ymin-extra
	xmax=xmax+extra
	ymax=ymax+extra
	--print(xmin,xmax,ymin,ymax)
	-- local xavg=xtotal/#self.focus	--TODO: maybe just (max+min)/2
	-- local yavg=ytotal/#self.focus
	local xavg=(xmax+xmin)/2
	local yavg=(ymax+ymin)/2
	--self.targetlocation={x=xavg,y=yavg}

	local arenaradius=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(50)
	
	local minzoom=0.35
	local maxzoom=2.5
	local multiplier=math.sqrt((self.zoom-minzoom)/maxzoom)
	local xloc,yloc=xavg*multiplier,yavg*multiplier
	
	--print(self.zoom,multiplier)
	--self.targetlocation={x=xloc,y=yloc}
	
	self.targetlocation={x=xavg+self.nudgex,y=yavg+self.nudgey}
	
end

