do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_ArenaBorder=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ArenaBorder
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.visible=true
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_ArenaBorder_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end	
	
	function class:CreateAssociatedObjects()
		--override; don't call super while overriding
		self.fill=TRAININGGROUNDS_BigCircle.new()
		self.fill:Setup(self.environment)		

	end
	
	function class:SetSize(diameter)
		local BORDER_WIDTH=20
		self.width=diameter+BORDER_WIDTH
		self.height=diameter+BORDER_WIDTH
		--TODO: we could have sworn the next two lines were built-in to PreDraw
				-- but they're not.  why aren't they, and should they be?		
		self.drawable.width=self.width+BORDER_WIDTH
		self.drawable.height=self.height+BORDER_WIDTH
		self.fill.width=diameter
		self.fill.height=diameter
		self.fill.drawable.width=self.width
		self.fill.drawable.height=self.height
	end
	
	function class:Cleanup()
		super.Cleanup(self)
		self.fill:Die()
	end
end

do
	local super=TRAININGGROUNDS_Drawable_Sprite
	TRAININGGROUNDS_ArenaBorder_Drawable=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ArenaBorder_Drawable	
	
	function class:CreateFrame()				
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.fill=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frames={}
		tinsert(self.frames,self.frame)
		tinsert(self.frames,self.fill)		
	end	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.filename_ex="Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\Misc\\bigquartercircle.tga"
		self.anchor="CENTER"		
		self.ystretch=true
	end
	
	local function quicksetup(parentframe,filename,point1,point2,tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4)
		local frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		frame:Show()	--TODO: check just in case this early Show has been causing raidmarker texture screen flash on restart
		frame.texture:Show()
		frame.texture:SetTexture(filename)
		frame.texture:SetTexCoord(tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4)
		frame:SetPoint(point1,parentframe,point1,0,0)
		frame:SetPoint(point2,parentframe,"CENTER",0,0)
		frame:SetParent(parentframe)		
		
		return frame
	end
	
	
	function class:SetFrameAppearance()
		self.fill:SetParent(self.frame)
		-- local HALFBORDERWIDTH=500
		-- self.fill:SetPoint("TOPLEFT",self.frame,"TOPLEFT",HALFBORDERWIDTH,-HALFBORDERWIDTH)
		-- self.fill:SetPoint("TOPRIGHT",self.frame,"TOPRIGHT",-HALFBORDERWIDTH,-HALFBORDERWIDTH)
		-- self.fill:SetPoint("BOTTOMRIGHT",self.frame,"BOTTOMRIGHT",-HALFBORDERWIDTH,HALFBORDERWIDTH)
		-- self.fill:SetPoint("BOTTOMLEFT",self.frame,"BOTTOMLEFT",HALFBORDERWIDTH,HALFBORDERWIDTH)
		
		
		local frame
		frame=quicksetup(self.frame,self.filename_ex,"TOPLEFT","BOTTOMRIGHT", 0,0, 0,1, 1,0, 1,1)
		tinsert(self.frames,frame)
		self.topleft=frame
		frame=quicksetup(self.frame,self.filename_ex,"TOPRIGHT","BOTTOMLEFT", 0,1, 1,1, 0,0, 1,0)
		tinsert(self.frames,frame)
		self.topright=frame
		frame=quicksetup(self.frame,self.filename_ex,"BOTTOMRIGHT","TOPLEFT", 1,1, 1,0, 0,1, 0,0)
		tinsert(self.frames,frame)
		self.bottomright=frame
		frame=quicksetup(self.frame,self.filename_ex,"BOTTOMLEFT","TOPRIGHT", 1,0, 0,0, 1,1, 0,1)
		tinsert(self.frames,frame)
		self.bottomleft=frame
		-- frame=quicksetup(self.fill,self.filename_ex,"TOPLEFT","BOTTOMRIGHT", 0,0, 0,1, 1,0, 1,1)
		-- tinsert(self.frames,frame)
		-- self.topleftfill=frame
		-- frame=quicksetup(self.fill,self.filename_ex,"TOPRIGHT","BOTTOMLEFT", 0,1, 1,1, 0,0, 1,0)
		-- tinsert(self.frames,frame)
		-- self.toprightfill=frame
		-- frame=quicksetup(self.fill,self.filename_ex,"BOTTOMRIGHT","TOPLEFT", 1,1, 1,0, 0,1, 0,0)
		-- tinsert(self.frames,frame)
		-- self.bottomrightfill=frame
		-- frame=quicksetup(self.fill,self.filename_ex,"BOTTOMLEFT","TOPRIGHT", 1,0, 0,0, 1,1, 0,1)
		-- tinsert(self.frames,frame)				
		-- self.bottomleftfill=frame
	end
	
	function class:SetColor(R,G,B,A,R2,G2,B2,A2)
		self.topleft.texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
		self.topright.texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
		self.bottomright.texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
		self.bottomleft.texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
		self.owner.fill.drawable:SetColor(R2,G2,B2,A2)
		-- self.topleftfill.texture:SetGradientAlpha("HORIZONTAL",R2,G2,B2,A2,R2,G2,B2,A2)
		-- self.toprightfill.texture:SetGradientAlpha("HORIZONTAL",R2,G2,B2,A2,R2,G2,B2,A2)
		-- self.bottomrightfill.texture:SetGradientAlpha("HORIZONTAL",R2,G2,B2,A2,R2,G2,B2,A2)
		-- self.bottomleftfill.texture:SetGradientAlpha("HORIZONTAL",R2,G2,B2,A2,R2,G2,B2,A2)
	end	
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.floorframelayer
	end
		
end
