function TRAININGGROUNDS_Transform_Rotate2D(x,y,angle,originx,originy)
	local x1=x-originx
	local y1=y-originy
	local x2=x1*math.cos(angle)-y1*math.sin(angle)
	local y2=y1*math.cos(angle)+x1*math.sin(angle)
	x2=x2+originx
	y2=y2+originy

	return x2,y2
end


function TRAININGGROUNDS_QuadraticFormula(a,b,c)
	local x1=(-b + math.sqrt(b*b-4*a*c))/(2*a)
	local x2=(-b - math.sqrt(b*b-4*a*c))/(2*a)
	return x1,x2
end



function TRAININGGROUNDS_MatrixMultiplicationRotation(x,y,z,ax,ay,az)
	local x2=x
	local y2=y
	local z2=z

													
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										math.cos(az),-math.sin(az),0,
										math.sin(az),math.cos(az),0,
										0,0,1)		
	--print("After AZ:",x2,y2,z2)									
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										1,0,0,
										0,math.cos(ax),-math.sin(ax),
										0,math.sin(ax),math.cos(ax))
	--print("After AX:",x2,y2,z2)
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										math.cos(ay),0,math.sin(ay),
										0,1,0,
										-math.sin(ay),0,math.cos(ay))
	--print("After AY:",x2,y2,z2)
								
										
	return x2,y2,z2
end

function TRAININGGROUNDS_MatrixMultiplicationRotation2(x,y,z,ax,ay,az)
	--TODO: by all rights this function should not work
	-- even if it did work it should cause everything else to break
	-- consult a mathematician
	local x2=x
	local y2=y
	local z2=z		
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										math.cos(ay),0,math.sin(ay),
										0,1,0,
										-math.sin(ay),0,math.cos(ay))
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										1,0,0,
										0,math.cos(ax),-math.sin(ax),
										0,math.sin(ax),math.cos(ax))
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										math.cos(az),-math.sin(az),0,
										math.sin(az),math.cos(az),0,
										0,0,1)		
	return x2,y2,z2
end

function TRAININGGROUNDS_MatrixMultiplication(x,y,z,a00,a10,a20,a01,a11,a21,a02,a12,a22)
	local x2,y2,z2
	x2=x*a00+y*a10+z*a20
	y2=x*a01+y*a11+z*a21
	z2=x*a02+y*a12+z*a22
	return x2,y2,z2
end


function TRAININGGROUNDS_SECRET35_PerspectiveTransform(x,y,z,far)
	-- Z is depth axis.  (TODO: this is still inconsistent with a few things)
	if(z<-far/2)then z=-far/2 end
	local x2,y2
	x2=x*far/(z+far)
	y2=y*far/(z+far)		
	--print(x2,y2)
	return x2,y2
end

function TRAININGGROUNDS_LineLineCollision(x1,y1,x2,y2,x3,y3,x4,y4)
	local denominator=((y4-y3)*(x2-x1)-(x4-x3)*(y2-y1))
	if(denominator==0)then return false end		--TODO: or segments could be colinear
	local t=((x4-x3)*(y1-y3)-(y4-y3)*(x1-x3))/denominator
	local u=((x2-x1)*(y1-y3)-(y2-y1)*(x1-x3))/denominator
	return(t>=0 and t<=1 and u>=0 and u<=1)
end

function TRAININGGROUNDS_LineRectangleCollision(x1,y1,x2,y2,x3,y3,x4,y4)
	return(
		TRAININGGROUNDS_LineLineCollision(x1,y1,x2,y2,		x3,y3,x3,y4)
		or TRAININGGROUNDS_LineLineCollision(x1,y1,x2,y2,	x4,y3,x4,y4)
		or TRAININGGROUNDS_LineLineCollision(x1,y1,x2,y2,	x3,y3,x4,y3)
		or TRAININGGROUNDS_LineLineCollision(x1,y1,x2,y2,	x3,y4,x4,y4)
	)
	--TODO: check if line is fully inside rectangle
end

